// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/BasisCurvesPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  BasisCurvesPrim::BasisCurvesPrim() : CurvesPrim() {}
  BasisCurvesPrim::BasisCurvesPrim(const Prim& prim) : CurvesPrim(prim) {
    validate();
  }
  BasisCurvesPrim::~BasisCurvesPrim() {}

  bool BasisCurvesPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = BasisCurvesPrim();
      return false;
    }
    return true;
  }

  bool BasisCurvesPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.BasisCurves);
  }
  
  BasisCurvesPrim BasisCurvesPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? BasisCurvesPrim(layer->definePrim(path, GeomTokens.types.BasisCurves)) : BasisCurvesPrim();
  }

  BasisCurvesPrim BasisCurvesPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? BasisCurvesPrim(layer->overridePrim(prim)) : BasisCurvesPrim();
  }

  BasisCurvesPrim BasisCurvesPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return BasisCurvesPrim(stage->getPrimAtPath(path));
  }

  Attribute BasisCurvesPrim::createBasisAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.basis, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute BasisCurvesPrim::getBasisAttr() const {
    return getAttr(GeomTokens.basis);
  }
  void BasisCurvesPrim::setBasis(const Token& value, fdk::TimeValue time) {
    createBasisAttr().setValue(value, time);
  }
  Token BasisCurvesPrim::getBasis(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.basis).getValue<Token>(v, time); return v;
  }

  Attribute BasisCurvesPrim::createTypeAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.type, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute BasisCurvesPrim::getTypeAttr() const {
    return getAttr(GeomTokens.type);
  }
  void BasisCurvesPrim::setType(const Token& value, fdk::TimeValue time) {
    createTypeAttr().setValue(value, time);
  }
  Token BasisCurvesPrim::getType(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.type).getValue<Token>(v, time); return v;
  }

  Attribute BasisCurvesPrim::createWrapAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.wrap, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute BasisCurvesPrim::getWrapAttr() const {
    return getAttr(GeomTokens.wrap);
  }
  void BasisCurvesPrim::setWrap(const Token& value, fdk::TimeValue time) {
    createWrapAttr().setValue(value, time);
  }
  Token BasisCurvesPrim::getWrap(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.wrap).getValue<Token>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
