// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/BoundablePrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  BoundablePrim::BoundablePrim() : XformablePrim() {}
  BoundablePrim::BoundablePrim(const Prim& prim) : XformablePrim(prim) {
    validate();
  }
  BoundablePrim::~BoundablePrim() {}

  bool BoundablePrim::validate() {
    if (!isValidPrim(*this)) {
      *this = BoundablePrim();
      return false;
    }
    return true;
  }

  bool BoundablePrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Boundable);
  }
  

  BoundablePrim BoundablePrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? BoundablePrim(layer->overridePrim(prim)) : BoundablePrim();
  }

  BoundablePrim BoundablePrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return BoundablePrim(stage->getPrimAtPath(path));
  }

  Attribute BoundablePrim::createExtentAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.extent, Value::Float3Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute BoundablePrim::getExtentAttr() const {
    return getAttr(GeomTokens.extent);
  }
  void BoundablePrim::setExtent(const Vec3fArray& value, fdk::TimeValue time) {
    createExtentAttr().setValue(value, time);
  }
  Vec3fArray BoundablePrim::getExtent(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.extent).getValue<Vec3fArray>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  /*! Create or set the point bounds (bbox) property at a specific time.
      Returns true on success.
  */
  /*virtual*/ bool
  BoundablePrim::setBoundsAttr(const fdk::Box3f&     point_bbox,
                               const fdk::TimeValue& time)
  {
    if (_pImpl) {
      setExtent(Vec3fArray {point_bbox.min, point_bbox.max}, time);
      return true;
    }
    return false;
  }

  /*! Create or set the point bounds (bbox) property from a list of points
      as a specific time.
      Returns true on success.
  */
  /*virtual*/ bool
  BoundablePrim::setBoundsAttr(const Vec3fArray&     points,
                               const fdk::TimeValue& time)
  {
    if (!_pImpl) {
      return false;
    }
    return setBoundsAttr(fdk::Box3f(points.data(), points.size()), time);
  }


  /*! Retrieve the bounds property.
      If it doesn't exist the returned Attr will be invalid.
  */
  /*virtual*/ Attribute
  BoundablePrim::getBoundsAttr() const
  {
    return Prim::getAttr(GeomTokens.extent);
  }

  /*virtual*/ fdk::Box3f
  BoundablePrim::getBoundsBox(const fdk::TimeValue& time,
                              bool                  build_from_points_fallback) const
  {
    if (Attribute attr = Prim::getAttr(GeomTokens.extent)) {
      Vec3fArray bounds;
      if (attr.getValue(bounds, time) == 2) {
        return fdk::Box3f(bounds[0], bounds[1]);
      }
    }

    if (build_from_points_fallback) {
      if (const auto pointsAttr = Prim::getAttr(GeomTokens.points)) {
        fdk::Box3f bbox;
        Vec3fArray points;
        pointsAttr.getValue(points, time);
        for (const auto p : points) {
          bbox.expand(p);
        }
      }
    }

    return fdk::Box3f();
  }
  // --(END CUSTOM CODE)--
}
