// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/CameraPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  CameraPrim::CameraPrim() : XformablePrim() {}
  CameraPrim::CameraPrim(const Prim& prim) : XformablePrim(prim) {
    validate();
  }
  CameraPrim::~CameraPrim() {}

  bool CameraPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = CameraPrim();
      return false;
    }
    return true;
  }

  bool CameraPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Camera);
  }
  
  CameraPrim CameraPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? CameraPrim(layer->definePrim(path, GeomTokens.types.Camera)) : CameraPrim();
  }

  CameraPrim CameraPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? CameraPrim(layer->overridePrim(prim)) : CameraPrim();
  }

  CameraPrim CameraPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return CameraPrim(stage->getPrimAtPath(path));
  }

  Attribute CameraPrim::createClippingPlanesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.clippingPlanes, Value::Float4Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getClippingPlanesAttr() const {
    return getAttr(GeomTokens.clippingPlanes);
  }
  void CameraPrim::setClippingPlanes(const Vec4fArray& value, fdk::TimeValue time) {
    createClippingPlanesAttr().setValue(value, time);
  }
  Vec4fArray CameraPrim::getClippingPlanes(fdk::TimeValue time) const {
    Vec4fArray v; getAttr(GeomTokens.clippingPlanes).getValue<Vec4fArray>(v, time); return v;
  }

  Attribute CameraPrim::createClippingRangeAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.clippingRange, Value::Float2, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getClippingRangeAttr() const {
    return getAttr(GeomTokens.clippingRange);
  }
  void CameraPrim::setClippingRange(const fdk::Vec2f& value, fdk::TimeValue time) {
    createClippingRangeAttr().setValue(value, time);
  }
  fdk::Vec2f CameraPrim::getClippingRange(fdk::TimeValue time) const {
    fdk::Vec2f v; getAttr(GeomTokens.clippingRange).getValue<fdk::Vec2f>(v, time); return v;
  }

  Attribute CameraPrim::createExposureAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.exposure, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getExposureAttr() const {
    return getAttr(GeomTokens.exposure);
  }
  void CameraPrim::setExposure(float value, fdk::TimeValue time) {
    createExposureAttr().setValue(value, time);
  }
  float CameraPrim::getExposure(fdk::TimeValue time) const {
    float v; getAttr(GeomTokens.exposure).getValue<float>(v, time); return v;
  }

  Attribute CameraPrim::createFocalLengthAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.focalLength, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getFocalLengthAttr() const {
    return getAttr(GeomTokens.focalLength);
  }
  void CameraPrim::setFocalLength(float value, fdk::TimeValue time) {
    createFocalLengthAttr().setValue(value, time);
  }
  float CameraPrim::getFocalLength(fdk::TimeValue time) const {
    float v; getAttr(GeomTokens.focalLength).getValue<float>(v, time); return v;
  }

  Attribute CameraPrim::createFocusDistanceAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.focusDistance, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getFocusDistanceAttr() const {
    return getAttr(GeomTokens.focusDistance);
  }
  void CameraPrim::setFocusDistance(float value, fdk::TimeValue time) {
    createFocusDistanceAttr().setValue(value, time);
  }
  float CameraPrim::getFocusDistance(fdk::TimeValue time) const {
    float v; getAttr(GeomTokens.focusDistance).getValue<float>(v, time); return v;
  }

  Attribute CameraPrim::createFStopAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.fStop, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getFStopAttr() const {
    return getAttr(GeomTokens.fStop);
  }
  void CameraPrim::setFStop(float value, fdk::TimeValue time) {
    createFStopAttr().setValue(value, time);
  }
  float CameraPrim::getFStop(fdk::TimeValue time) const {
    float v; getAttr(GeomTokens.fStop).getValue<float>(v, time); return v;
  }

  Attribute CameraPrim::createHorizontalApertureAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.horizontalAperture, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getHorizontalApertureAttr() const {
    return getAttr(GeomTokens.horizontalAperture);
  }
  void CameraPrim::setHorizontalAperture(float value, fdk::TimeValue time) {
    createHorizontalApertureAttr().setValue(value, time);
  }
  float CameraPrim::getHorizontalAperture(fdk::TimeValue time) const {
    float v; getAttr(GeomTokens.horizontalAperture).getValue<float>(v, time); return v;
  }

  Attribute CameraPrim::createHorizontalApertureOffsetAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.horizontalApertureOffset, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getHorizontalApertureOffsetAttr() const {
    return getAttr(GeomTokens.horizontalApertureOffset);
  }
  void CameraPrim::setHorizontalApertureOffset(float value, fdk::TimeValue time) {
    createHorizontalApertureOffsetAttr().setValue(value, time);
  }
  float CameraPrim::getHorizontalApertureOffset(fdk::TimeValue time) const {
    float v; getAttr(GeomTokens.horizontalApertureOffset).getValue<float>(v, time); return v;
  }

  Attribute CameraPrim::createProjectionAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.projection, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getProjectionAttr() const {
    return getAttr(GeomTokens.projection);
  }
  void CameraPrim::setProjection(const Token& value, fdk::TimeValue time) {
    createProjectionAttr().setValue(value, time);
  }
  Token CameraPrim::getProjection(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.projection).getValue<Token>(v, time); return v;
  }

  Attribute CameraPrim::createCloseAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.shutterClose, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getCloseAttr() const {
    return getAttr(GeomTokens.shutterClose);
  }
  void CameraPrim::setClose(double value, fdk::TimeValue time) {
    createCloseAttr().setValue(value, time);
  }
  double CameraPrim::getClose(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.shutterClose).getValue<double>(v, time); return v;
  }

  Attribute CameraPrim::createOpenAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.shutterOpen, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getOpenAttr() const {
    return getAttr(GeomTokens.shutterOpen);
  }
  void CameraPrim::setOpen(double value, fdk::TimeValue time) {
    createOpenAttr().setValue(value, time);
  }
  double CameraPrim::getOpen(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.shutterOpen).getValue<double>(v, time); return v;
  }

  Attribute CameraPrim::createStereoRoleAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.stereoRole, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute CameraPrim::getStereoRoleAttr() const {
    return getAttr(GeomTokens.stereoRole);
  }
  void CameraPrim::setStereoRole(const Token& value, fdk::TimeValue time) {
    createStereoRoleAttr().setValue(value, time);
  }
  Token CameraPrim::getStereoRole(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.stereoRole).getValue<Token>(v, time); return v;
  }

  Attribute CameraPrim::createVerticalApertureAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.verticalAperture, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getVerticalApertureAttr() const {
    return getAttr(GeomTokens.verticalAperture);
  }
  void CameraPrim::setVerticalAperture(float value, fdk::TimeValue time) {
    createVerticalApertureAttr().setValue(value, time);
  }
  float CameraPrim::getVerticalAperture(fdk::TimeValue time) const {
    float v; getAttr(GeomTokens.verticalAperture).getValue<float>(v, time); return v;
  }

  Attribute CameraPrim::createVerticalApertureOffsetAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.verticalApertureOffset, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CameraPrim::getVerticalApertureOffsetAttr() const {
    return getAttr(GeomTokens.verticalApertureOffset);
  }
  void CameraPrim::setVerticalApertureOffset(float value, fdk::TimeValue time) {
    createVerticalApertureOffsetAttr().setValue(value, time);
  }
  float CameraPrim::getVerticalApertureOffset(fdk::TimeValue time) const {
    float v; getAttr(GeomTokens.verticalApertureOffset).getValue<float>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
