// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/CapsulePrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  CapsulePrim::CapsulePrim() : GprimPrim() {}
  CapsulePrim::CapsulePrim(const Prim& prim) : GprimPrim(prim) {
    validate();
  }
  CapsulePrim::~CapsulePrim() {}

  bool CapsulePrim::validate() {
    if (!isValidPrim(*this)) {
      *this = CapsulePrim();
      return false;
    }
    return true;
  }

  bool CapsulePrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Capsule);
  }
  
  CapsulePrim CapsulePrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? CapsulePrim(layer->definePrim(path, GeomTokens.types.Capsule)) : CapsulePrim();
  }

  CapsulePrim CapsulePrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? CapsulePrim(layer->overridePrim(prim)) : CapsulePrim();
  }

  CapsulePrim CapsulePrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return CapsulePrim(stage->getPrimAtPath(path));
  }

  Attribute CapsulePrim::createAxisAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.axis, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute CapsulePrim::getAxisAttr() const {
    return getAttr(GeomTokens.axis);
  }
  void CapsulePrim::setAxis(const Token& value, fdk::TimeValue time) {
    createAxisAttr().setValue(value, time);
  }
  Token CapsulePrim::getAxis(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.axis).getValue<Token>(v, time); return v;
  }

  Attribute CapsulePrim::createHeightAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.height, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CapsulePrim::getHeightAttr() const {
    return getAttr(GeomTokens.height);
  }
  void CapsulePrim::setHeight(double value, fdk::TimeValue time) {
    createHeightAttr().setValue(value, time);
  }
  double CapsulePrim::getHeight(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.height).getValue<double>(v, time); return v;
  }

  Attribute CapsulePrim::createRadiusAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.radius, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CapsulePrim::getRadiusAttr() const {
    return getAttr(GeomTokens.radius);
  }
  void CapsulePrim::setRadius(double value, fdk::TimeValue time) {
    createRadiusAttr().setValue(value, time);
  }
  double CapsulePrim::getRadius(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.radius).getValue<double>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
