// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/CollectionAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace {
  usg::Token namespacedAttr(const usg::Token& name, const usg::Token& attr) {
    return usg::Token("collection:" + name.asString() + ":" + attr.asString());
  }
}

namespace usg {

  CollectionAPI::CollectionAPI() : _prim() {}
  CollectionAPI::CollectionAPI(const Prim& prim, const Token& name) : _prim(prim), _name(name) {
    validate();
  }
  CollectionAPI::~CollectionAPI() {}

  bool CollectionAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = CollectionAPI();
      return false;
    }
    return true;
  }

  bool CollectionAPI::isValidPrim(const Prim& prim, const Token& instanceName) {
    return prim.hasApi(Tokens.types.CollectionAPI, instanceName);
  }

  void CollectionAPI::apply() {
    _prim.addAppliedSchema(Tokens.types.CollectionAPI.asString() + ":" + _name.asString());
  }

  Relationship CollectionAPI::createExcludesRel() {
    return _prim.createRelationship(namespacedAttr(_name, Tokens.excludes));
  }
  Relationship CollectionAPI::getExcludesRel() const {
    return _prim.getRelationship(namespacedAttr(_name, Tokens.excludes));
  }
  void CollectionAPI::setExcludes(const PathArray& value, fdk::TimeValue time) {
    _prim.createRelationship(namespacedAttr(_name, Tokens.excludes)).setTargets(value);
  }
  PathArray CollectionAPI::getExcludes(fdk::TimeValue time) const {
    return _prim.getRelationship(namespacedAttr(_name, Tokens.excludes)).getTargets();
  }

  Attribute CollectionAPI::createExpansionRuleAttr(const Value& defaultValue) {
    return _prim.createAttr(namespacedAttr(_name, Tokens.expansionRule), Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute CollectionAPI::getExpansionRuleAttr() const {
    return _prim.getAttr(namespacedAttr(_name, Tokens.expansionRule));
  }
  void CollectionAPI::setExpansionRule(const Token& value, fdk::TimeValue time) {
    createExpansionRuleAttr().setValue(value, time);
  }
  Token CollectionAPI::getExpansionRule(fdk::TimeValue time) const {
    Token v; _prim.getAttr(namespacedAttr(_name, Tokens.expansionRule)).getValue<Token>(v, time); return v;
  }

  Attribute CollectionAPI::createIncludeRootAttr(const Value& defaultValue) {
    return _prim.createAttr(namespacedAttr(_name, Tokens.includeRoot), Value::Bool, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute CollectionAPI::getIncludeRootAttr() const {
    return _prim.getAttr(namespacedAttr(_name, Tokens.includeRoot));
  }
  void CollectionAPI::setIncludeRoot(bool value, fdk::TimeValue time) {
    createIncludeRootAttr().setValue(value, time);
  }
  bool CollectionAPI::getIncludeRoot(fdk::TimeValue time) const {
    bool v; _prim.getAttr(namespacedAttr(_name, Tokens.includeRoot)).getValue<bool>(v, time); return v;
  }

  Relationship CollectionAPI::createIncludesRel() {
    return _prim.createRelationship(namespacedAttr(_name, Tokens.includes));
  }
  Relationship CollectionAPI::getIncludesRel() const {
    return _prim.getRelationship(namespacedAttr(_name, Tokens.includes));
  }
  void CollectionAPI::setIncludes(const PathArray& value, fdk::TimeValue time) {
    _prim.createRelationship(namespacedAttr(_name, Tokens.includes)).setTargets(value);
  }
  PathArray CollectionAPI::getIncludes(fdk::TimeValue time) const {
    return _prim.getRelationship(namespacedAttr(_name, Tokens.includes)).getTargets();
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
