// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/ConePrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  ConePrim::ConePrim() : GprimPrim() {}
  ConePrim::ConePrim(const Prim& prim) : GprimPrim(prim) {
    validate();
  }
  ConePrim::~ConePrim() {}

  bool ConePrim::validate() {
    if (!isValidPrim(*this)) {
      *this = ConePrim();
      return false;
    }
    return true;
  }

  bool ConePrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Cone);
  }
  
  ConePrim ConePrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? ConePrim(layer->definePrim(path, GeomTokens.types.Cone)) : ConePrim();
  }

  ConePrim ConePrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? ConePrim(layer->overridePrim(prim)) : ConePrim();
  }

  ConePrim ConePrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return ConePrim(stage->getPrimAtPath(path));
  }

  Attribute ConePrim::createAxisAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.axis, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute ConePrim::getAxisAttr() const {
    return getAttr(GeomTokens.axis);
  }
  void ConePrim::setAxis(const Token& value, fdk::TimeValue time) {
    createAxisAttr().setValue(value, time);
  }
  Token ConePrim::getAxis(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.axis).getValue<Token>(v, time); return v;
  }

  Attribute ConePrim::createHeightAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.height, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ConePrim::getHeightAttr() const {
    return getAttr(GeomTokens.height);
  }
  void ConePrim::setHeight(double value, fdk::TimeValue time) {
    createHeightAttr().setValue(value, time);
  }
  double ConePrim::getHeight(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.height).getValue<double>(v, time); return v;
  }

  Attribute ConePrim::createRadiusAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.radius, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ConePrim::getRadiusAttr() const {
    return getAttr(GeomTokens.radius);
  }
  void ConePrim::setRadius(double value, fdk::TimeValue time) {
    createRadiusAttr().setValue(value, time);
  }
  double ConePrim::getRadius(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.radius).getValue<double>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
