// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/CubePrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  CubePrim::CubePrim() : GprimPrim() {}
  CubePrim::CubePrim(const Prim& prim) : GprimPrim(prim) {
    validate();
  }
  CubePrim::~CubePrim() {}

  bool CubePrim::validate() {
    if (!isValidPrim(*this)) {
      *this = CubePrim();
      return false;
    }
    return true;
  }

  bool CubePrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Cube);
  }
  
  CubePrim CubePrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? CubePrim(layer->definePrim(path, GeomTokens.types.Cube)) : CubePrim();
  }

  CubePrim CubePrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? CubePrim(layer->overridePrim(prim)) : CubePrim();
  }

  CubePrim CubePrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return CubePrim(stage->getPrimAtPath(path));
  }

  Attribute CubePrim::createSizeAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.size, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CubePrim::getSizeAttr() const {
    return getAttr(GeomTokens.size);
  }
  void CubePrim::setSize(double value, fdk::TimeValue time) {
    createSizeAttr().setValue(value, time);
  }
  double CubePrim::getSize(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.size).getValue<double>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
