// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/CurvesPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  CurvesPrim::CurvesPrim() : PointBasedPrim() {}
  CurvesPrim::CurvesPrim(const Prim& prim) : PointBasedPrim(prim) {
    validate();
  }
  CurvesPrim::~CurvesPrim() {}

  bool CurvesPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = CurvesPrim();
      return false;
    }
    return true;
  }

  bool CurvesPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Curves);
  }
  

  CurvesPrim CurvesPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? CurvesPrim(layer->overridePrim(prim)) : CurvesPrim();
  }

  CurvesPrim CurvesPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return CurvesPrim(stage->getPrimAtPath(path));
  }

  Attribute CurvesPrim::createCurveVertexCountsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.curveVertexCounts, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CurvesPrim::getCurveVertexCountsAttr() const {
    return getAttr(GeomTokens.curveVertexCounts);
  }
  void CurvesPrim::setCurveVertexCounts(const IntArray& value, fdk::TimeValue time) {
    createCurveVertexCountsAttr().setValue(value, time);
  }
  IntArray CurvesPrim::getCurveVertexCounts(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.curveVertexCounts).getValue<IntArray>(v, time); return v;
  }

  Attribute CurvesPrim::createWidthsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.widths, Value::FloatArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CurvesPrim::getWidthsAttr() const {
    return getAttr(GeomTokens.widths);
  }
  void CurvesPrim::setWidths(const FloatArray& value, fdk::TimeValue time) {
    createWidthsAttr().setValue(value, time);
  }
  FloatArray CurvesPrim::getWidths(fdk::TimeValue time) const {
    FloatArray v; getAttr(GeomTokens.widths).getValue<FloatArray>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
