// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/CylinderPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  CylinderPrim::CylinderPrim() : GprimPrim() {}
  CylinderPrim::CylinderPrim(const Prim& prim) : GprimPrim(prim) {
    validate();
  }
  CylinderPrim::~CylinderPrim() {}

  bool CylinderPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = CylinderPrim();
      return false;
    }
    return true;
  }

  bool CylinderPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Cylinder);
  }
  
  CylinderPrim CylinderPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? CylinderPrim(layer->definePrim(path, GeomTokens.types.Cylinder)) : CylinderPrim();
  }

  CylinderPrim CylinderPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? CylinderPrim(layer->overridePrim(prim)) : CylinderPrim();
  }

  CylinderPrim CylinderPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return CylinderPrim(stage->getPrimAtPath(path));
  }

  Attribute CylinderPrim::createAxisAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.axis, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute CylinderPrim::getAxisAttr() const {
    return getAttr(GeomTokens.axis);
  }
  void CylinderPrim::setAxis(const Token& value, fdk::TimeValue time) {
    createAxisAttr().setValue(value, time);
  }
  Token CylinderPrim::getAxis(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.axis).getValue<Token>(v, time); return v;
  }

  Attribute CylinderPrim::createHeightAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.height, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderPrim::getHeightAttr() const {
    return getAttr(GeomTokens.height);
  }
  void CylinderPrim::setHeight(double value, fdk::TimeValue time) {
    createHeightAttr().setValue(value, time);
  }
  double CylinderPrim::getHeight(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.height).getValue<double>(v, time); return v;
  }

  Attribute CylinderPrim::createRadiusAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.radius, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderPrim::getRadiusAttr() const {
    return getAttr(GeomTokens.radius);
  }
  void CylinderPrim::setRadius(double value, fdk::TimeValue time) {
    createRadiusAttr().setValue(value, time);
  }
  double CylinderPrim::getRadius(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.radius).getValue<double>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
