// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/GeomModelAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  GeomModelAPI::GeomModelAPI() : _prim() {}
  GeomModelAPI::GeomModelAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  GeomModelAPI::~GeomModelAPI() {}

  bool GeomModelAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = GeomModelAPI();
      return false;
    }
    return true;
  }

  bool GeomModelAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(GeomTokens.types.GeomModelAPI);
  }
  
  void GeomModelAPI::apply() {
    _prim.addAppliedSchema(GeomTokens.types.GeomModelAPI);
  }

  Attribute GeomModelAPI::createApplyDrawModeAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelApplyDrawMode, Value::Bool, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GeomModelAPI::getApplyDrawModeAttr() const {
    return _prim.getAttr(GeomTokens.modelApplyDrawMode);
  }
  void GeomModelAPI::setApplyDrawMode(bool value, fdk::TimeValue time) {
    createApplyDrawModeAttr().setValue(value, time);
  }
  bool GeomModelAPI::getApplyDrawMode(fdk::TimeValue time) const {
    bool v; _prim.getAttr(GeomTokens.modelApplyDrawMode).getValue<bool>(v, time); return v;
  }

  Attribute GeomModelAPI::createCardGeometryAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelCardGeometry, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GeomModelAPI::getCardGeometryAttr() const {
    return _prim.getAttr(GeomTokens.modelCardGeometry);
  }
  void GeomModelAPI::setCardGeometry(const Token& value, fdk::TimeValue time) {
    createCardGeometryAttr().setValue(value, time);
  }
  Token GeomModelAPI::getCardGeometry(fdk::TimeValue time) const {
    Token v; _prim.getAttr(GeomTokens.modelCardGeometry).getValue<Token>(v, time); return v;
  }

  Attribute GeomModelAPI::createCardTextureXNegAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelCardTextureXNeg, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeomModelAPI::getCardTextureXNegAttr() const {
    return _prim.getAttr(GeomTokens.modelCardTextureXNeg);
  }
  void GeomModelAPI::setCardTextureXNeg(const AssetPath& value, fdk::TimeValue time) {
    createCardTextureXNegAttr().setValue(value, time);
  }
  AssetPath GeomModelAPI::getCardTextureXNeg(fdk::TimeValue time) const {
    AssetPath v; _prim.getAttr(GeomTokens.modelCardTextureXNeg).getValue<AssetPath>(v, time); return v;
  }

  Attribute GeomModelAPI::createCardTextureXPosAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelCardTextureXPos, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeomModelAPI::getCardTextureXPosAttr() const {
    return _prim.getAttr(GeomTokens.modelCardTextureXPos);
  }
  void GeomModelAPI::setCardTextureXPos(const AssetPath& value, fdk::TimeValue time) {
    createCardTextureXPosAttr().setValue(value, time);
  }
  AssetPath GeomModelAPI::getCardTextureXPos(fdk::TimeValue time) const {
    AssetPath v; _prim.getAttr(GeomTokens.modelCardTextureXPos).getValue<AssetPath>(v, time); return v;
  }

  Attribute GeomModelAPI::createCardTextureYNegAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelCardTextureYNeg, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeomModelAPI::getCardTextureYNegAttr() const {
    return _prim.getAttr(GeomTokens.modelCardTextureYNeg);
  }
  void GeomModelAPI::setCardTextureYNeg(const AssetPath& value, fdk::TimeValue time) {
    createCardTextureYNegAttr().setValue(value, time);
  }
  AssetPath GeomModelAPI::getCardTextureYNeg(fdk::TimeValue time) const {
    AssetPath v; _prim.getAttr(GeomTokens.modelCardTextureYNeg).getValue<AssetPath>(v, time); return v;
  }

  Attribute GeomModelAPI::createCardTextureYPosAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelCardTextureYPos, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeomModelAPI::getCardTextureYPosAttr() const {
    return _prim.getAttr(GeomTokens.modelCardTextureYPos);
  }
  void GeomModelAPI::setCardTextureYPos(const AssetPath& value, fdk::TimeValue time) {
    createCardTextureYPosAttr().setValue(value, time);
  }
  AssetPath GeomModelAPI::getCardTextureYPos(fdk::TimeValue time) const {
    AssetPath v; _prim.getAttr(GeomTokens.modelCardTextureYPos).getValue<AssetPath>(v, time); return v;
  }

  Attribute GeomModelAPI::createCardTextureZNegAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelCardTextureZNeg, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeomModelAPI::getCardTextureZNegAttr() const {
    return _prim.getAttr(GeomTokens.modelCardTextureZNeg);
  }
  void GeomModelAPI::setCardTextureZNeg(const AssetPath& value, fdk::TimeValue time) {
    createCardTextureZNegAttr().setValue(value, time);
  }
  AssetPath GeomModelAPI::getCardTextureZNeg(fdk::TimeValue time) const {
    AssetPath v; _prim.getAttr(GeomTokens.modelCardTextureZNeg).getValue<AssetPath>(v, time); return v;
  }

  Attribute GeomModelAPI::createCardTextureZPosAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelCardTextureZPos, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeomModelAPI::getCardTextureZPosAttr() const {
    return _prim.getAttr(GeomTokens.modelCardTextureZPos);
  }
  void GeomModelAPI::setCardTextureZPos(const AssetPath& value, fdk::TimeValue time) {
    createCardTextureZPosAttr().setValue(value, time);
  }
  AssetPath GeomModelAPI::getCardTextureZPos(fdk::TimeValue time) const {
    AssetPath v; _prim.getAttr(GeomTokens.modelCardTextureZPos).getValue<AssetPath>(v, time); return v;
  }

  Attribute GeomModelAPI::createDrawModeAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelDrawMode, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GeomModelAPI::getDrawModeAttr() const {
    return _prim.getAttr(GeomTokens.modelDrawMode);
  }
  void GeomModelAPI::setDrawMode(const Token& value, fdk::TimeValue time) {
    createDrawModeAttr().setValue(value, time);
  }
  Token GeomModelAPI::getDrawMode(fdk::TimeValue time) const {
    Token v; _prim.getAttr(GeomTokens.modelDrawMode).getValue<Token>(v, time); return v;
  }

  Attribute GeomModelAPI::createDrawModeColorAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.modelDrawModeColor, Value::Float3, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GeomModelAPI::getDrawModeColorAttr() const {
    return _prim.getAttr(GeomTokens.modelDrawModeColor);
  }
  void GeomModelAPI::setDrawModeColor(const fdk::Vec3f& value, fdk::TimeValue time) {
    createDrawModeColorAttr().setValue(value, time);
  }
  fdk::Vec3f GeomModelAPI::getDrawModeColor(fdk::TimeValue time) const {
    fdk::Vec3f v; _prim.getAttr(GeomTokens.modelDrawModeColor).getValue<fdk::Vec3f>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
