// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/GprimPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  GprimPrim::GprimPrim() : BoundablePrim() {}
  GprimPrim::GprimPrim(const Prim& prim) : BoundablePrim(prim) {
    validate();
  }
  GprimPrim::~GprimPrim() {}

  bool GprimPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = GprimPrim();
      return false;
    }
    return true;
  }

  bool GprimPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Gprim);
  }
  

  GprimPrim GprimPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? GprimPrim(layer->overridePrim(prim)) : GprimPrim();
  }

  GprimPrim GprimPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return GprimPrim(stage->getPrimAtPath(path));
  }

  Attribute GprimPrim::createDoubleSidedAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.doubleSided, Value::Bool, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GprimPrim::getDoubleSidedAttr() const {
    return getAttr(GeomTokens.doubleSided);
  }
  void GprimPrim::setDoubleSided(bool value, fdk::TimeValue time) {
    createDoubleSidedAttr().setValue(value, time);
  }
  bool GprimPrim::getDoubleSided(fdk::TimeValue time) const {
    bool v; getAttr(GeomTokens.doubleSided).getValue<bool>(v, time); return v;
  }

  Attribute GprimPrim::createOrientationAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.orientation, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GprimPrim::getOrientationAttr() const {
    return getAttr(GeomTokens.orientation);
  }
  void GprimPrim::setOrientation(const Token& value, fdk::TimeValue time) {
    createOrientationAttr().setValue(value, time);
  }
  Token GprimPrim::getOrientation(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.orientation).getValue<Token>(v, time); return v;
  }

  Attribute GprimPrim::createDisplayColorAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.primvarsDisplayColor, Value::Color3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GprimPrim::getDisplayColorAttr() const {
    return getAttr(GeomTokens.primvarsDisplayColor);
  }
  void GprimPrim::setDisplayColor(const Vec3fArray& value, fdk::TimeValue time) {
    createDisplayColorAttr().setValue(value, time);
  }
  Vec3fArray GprimPrim::getDisplayColor(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.primvarsDisplayColor).getValue<Vec3fArray>(v, time); return v;
  }

  Attribute GprimPrim::createDisplayOpacityAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.primvarsDisplayOpacity, Value::FloatArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GprimPrim::getDisplayOpacityAttr() const {
    return getAttr(GeomTokens.primvarsDisplayOpacity);
  }
  void GprimPrim::setDisplayOpacity(const FloatArray& value, fdk::TimeValue time) {
    createDisplayOpacityAttr().setValue(value, time);
  }
  FloatArray GprimPrim::getDisplayOpacity(fdk::TimeValue time) const {
    FloatArray v; getAttr(GeomTokens.primvarsDisplayOpacity).getValue<FloatArray>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
