// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/HermiteCurvesPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  HermiteCurvesPrim::HermiteCurvesPrim() : CurvesPrim() {}
  HermiteCurvesPrim::HermiteCurvesPrim(const Prim& prim) : CurvesPrim(prim) {
    validate();
  }
  HermiteCurvesPrim::~HermiteCurvesPrim() {}

  bool HermiteCurvesPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = HermiteCurvesPrim();
      return false;
    }
    return true;
  }

  bool HermiteCurvesPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.HermiteCurves);
  }
  
  HermiteCurvesPrim HermiteCurvesPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? HermiteCurvesPrim(layer->definePrim(path, GeomTokens.types.HermiteCurves)) : HermiteCurvesPrim();
  }

  HermiteCurvesPrim HermiteCurvesPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? HermiteCurvesPrim(layer->overridePrim(prim)) : HermiteCurvesPrim();
  }

  HermiteCurvesPrim HermiteCurvesPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return HermiteCurvesPrim(stage->getPrimAtPath(path));
  }

  Attribute HermiteCurvesPrim::createTangentsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.tangents, Value::Vector3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute HermiteCurvesPrim::getTangentsAttr() const {
    return getAttr(GeomTokens.tangents);
  }
  void HermiteCurvesPrim::setTangents(const Vec3fArray& value, fdk::TimeValue time) {
    createTangentsAttr().setValue(value, time);
  }
  Vec3fArray HermiteCurvesPrim::getTangents(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.tangents).getValue<Vec3fArray>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
