// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/ImageablePrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  ImageablePrim::ImageablePrim() : Prim() {}
  ImageablePrim::ImageablePrim(const Prim& prim) : Prim(prim) {
    validate();
  }
  ImageablePrim::~ImageablePrim() {}

  bool ImageablePrim::validate() {
    if (!isValidPrim(*this)) {
      *this = ImageablePrim();
      return false;
    }
    return true;
  }

  bool ImageablePrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Imageable);
  }
  

  ImageablePrim ImageablePrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? ImageablePrim(layer->overridePrim(prim)) : ImageablePrim();
  }

  ImageablePrim ImageablePrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return ImageablePrim(stage->getPrimAtPath(path));
  }

  Relationship ImageablePrim::createProxyPrimRel() {
    return createRelationship(GeomTokens.proxyPrim);
  }
  Relationship ImageablePrim::getProxyPrimRel() const {
    return getRelationship(GeomTokens.proxyPrim);
  }
  void ImageablePrim::setProxyPrim(const PathArray& value, fdk::TimeValue time) {
    createRelationship(GeomTokens.proxyPrim).setTargets(value);
  }
  PathArray ImageablePrim::getProxyPrim(fdk::TimeValue time) const {
    return getRelationship(GeomTokens.proxyPrim).getTargets();
  }

  Attribute ImageablePrim::createPurposeAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.purpose, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute ImageablePrim::getPurposeAttr() const {
    return getAttr(GeomTokens.purpose);
  }
  void ImageablePrim::setPurpose(const Token& value, fdk::TimeValue time) {
    createPurposeAttr().setValue(value, time);
  }
  Token ImageablePrim::getPurpose(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.purpose).getValue<Token>(v, time); return v;
  }

  Attribute ImageablePrim::createVisibilityAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.visibility, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ImageablePrim::getVisibilityAttr() const {
    return getAttr(GeomTokens.visibility);
  }
  void ImageablePrim::setVisibility(const Token& value, fdk::TimeValue time) {
    createVisibilityAttr().setValue(value, time);
  }
  Token ImageablePrim::getVisibility(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.visibility).getValue<Token>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
