// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/MeshPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  MeshPrim::MeshPrim() : PointBasedPrim() {}
  MeshPrim::MeshPrim(const Prim& prim) : PointBasedPrim(prim) {
    validate();
  }
  MeshPrim::~MeshPrim() {}

  bool MeshPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = MeshPrim();
      return false;
    }
    return true;
  }

  bool MeshPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Mesh);
  }
  
  MeshPrim MeshPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? MeshPrim(layer->definePrim(path, GeomTokens.types.Mesh)) : MeshPrim();
  }

  MeshPrim MeshPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? MeshPrim(layer->overridePrim(prim)) : MeshPrim();
  }

  MeshPrim MeshPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return MeshPrim(stage->getPrimAtPath(path));
  }

  Attribute MeshPrim::createCornerIndicesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.cornerIndices, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getCornerIndicesAttr() const {
    return getAttr(GeomTokens.cornerIndices);
  }
  void MeshPrim::setCornerIndices(const IntArray& value, fdk::TimeValue time) {
    createCornerIndicesAttr().setValue(value, time);
  }
  IntArray MeshPrim::getCornerIndices(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.cornerIndices).getValue<IntArray>(v, time); return v;
  }

  Attribute MeshPrim::createCornerSharpnessesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.cornerSharpnesses, Value::FloatArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getCornerSharpnessesAttr() const {
    return getAttr(GeomTokens.cornerSharpnesses);
  }
  void MeshPrim::setCornerSharpnesses(const FloatArray& value, fdk::TimeValue time) {
    createCornerSharpnessesAttr().setValue(value, time);
  }
  FloatArray MeshPrim::getCornerSharpnesses(fdk::TimeValue time) const {
    FloatArray v; getAttr(GeomTokens.cornerSharpnesses).getValue<FloatArray>(v, time); return v;
  }

  Attribute MeshPrim::createCreaseIndicesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.creaseIndices, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getCreaseIndicesAttr() const {
    return getAttr(GeomTokens.creaseIndices);
  }
  void MeshPrim::setCreaseIndices(const IntArray& value, fdk::TimeValue time) {
    createCreaseIndicesAttr().setValue(value, time);
  }
  IntArray MeshPrim::getCreaseIndices(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.creaseIndices).getValue<IntArray>(v, time); return v;
  }

  Attribute MeshPrim::createCreaseLengthsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.creaseLengths, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getCreaseLengthsAttr() const {
    return getAttr(GeomTokens.creaseLengths);
  }
  void MeshPrim::setCreaseLengths(const IntArray& value, fdk::TimeValue time) {
    createCreaseLengthsAttr().setValue(value, time);
  }
  IntArray MeshPrim::getCreaseLengths(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.creaseLengths).getValue<IntArray>(v, time); return v;
  }

  Attribute MeshPrim::createCreaseSharpnessesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.creaseSharpnesses, Value::FloatArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getCreaseSharpnessesAttr() const {
    return getAttr(GeomTokens.creaseSharpnesses);
  }
  void MeshPrim::setCreaseSharpnesses(const FloatArray& value, fdk::TimeValue time) {
    createCreaseSharpnessesAttr().setValue(value, time);
  }
  FloatArray MeshPrim::getCreaseSharpnesses(fdk::TimeValue time) const {
    FloatArray v; getAttr(GeomTokens.creaseSharpnesses).getValue<FloatArray>(v, time); return v;
  }

  Attribute MeshPrim::createFaceVaryingLinearInterpolationAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.faceVaryingLinearInterpolation, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getFaceVaryingLinearInterpolationAttr() const {
    return getAttr(GeomTokens.faceVaryingLinearInterpolation);
  }
  void MeshPrim::setFaceVaryingLinearInterpolation(const Token& value, fdk::TimeValue time) {
    createFaceVaryingLinearInterpolationAttr().setValue(value, time);
  }
  Token MeshPrim::getFaceVaryingLinearInterpolation(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.faceVaryingLinearInterpolation).getValue<Token>(v, time); return v;
  }

  Attribute MeshPrim::createFaceVertexCountsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.faceVertexCounts, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getFaceVertexCountsAttr() const {
    return getAttr(GeomTokens.faceVertexCounts);
  }
  void MeshPrim::setFaceVertexCounts(const IntArray& value, fdk::TimeValue time) {
    createFaceVertexCountsAttr().setValue(value, time);
  }
  IntArray MeshPrim::getFaceVertexCounts(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.faceVertexCounts).getValue<IntArray>(v, time); return v;
  }

  Attribute MeshPrim::createFaceVertexIndicesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.faceVertexIndices, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getFaceVertexIndicesAttr() const {
    return getAttr(GeomTokens.faceVertexIndices);
  }
  void MeshPrim::setFaceVertexIndices(const IntArray& value, fdk::TimeValue time) {
    createFaceVertexIndicesAttr().setValue(value, time);
  }
  IntArray MeshPrim::getFaceVertexIndices(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.faceVertexIndices).getValue<IntArray>(v, time); return v;
  }

  Attribute MeshPrim::createHoleIndicesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.holeIndices, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getHoleIndicesAttr() const {
    return getAttr(GeomTokens.holeIndices);
  }
  void MeshPrim::setHoleIndices(const IntArray& value, fdk::TimeValue time) {
    createHoleIndicesAttr().setValue(value, time);
  }
  IntArray MeshPrim::getHoleIndices(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.holeIndices).getValue<IntArray>(v, time); return v;
  }

  Attribute MeshPrim::createInterpolateBoundaryAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.interpolateBoundary, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getInterpolateBoundaryAttr() const {
    return getAttr(GeomTokens.interpolateBoundary);
  }
  void MeshPrim::setInterpolateBoundary(const Token& value, fdk::TimeValue time) {
    createInterpolateBoundaryAttr().setValue(value, time);
  }
  Token MeshPrim::getInterpolateBoundary(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.interpolateBoundary).getValue<Token>(v, time); return v;
  }

  Attribute MeshPrim::createSubdivisionSchemeAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.subdivisionScheme, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute MeshPrim::getSubdivisionSchemeAttr() const {
    return getAttr(GeomTokens.subdivisionScheme);
  }
  void MeshPrim::setSubdivisionScheme(const Token& value, fdk::TimeValue time) {
    createSubdivisionSchemeAttr().setValue(value, time);
  }
  Token MeshPrim::getSubdivisionScheme(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.subdivisionScheme).getValue<Token>(v, time); return v;
  }

  Attribute MeshPrim::createTriangleSubdivisionRuleAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.triangleSubdivisionRule, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MeshPrim::getTriangleSubdivisionRuleAttr() const {
    return getAttr(GeomTokens.triangleSubdivisionRule);
  }
  void MeshPrim::setTriangleSubdivisionRule(const Token& value, fdk::TimeValue time) {
    createTriangleSubdivisionRuleAttr().setValue(value, time);
  }
  Token MeshPrim::getTriangleSubdivisionRule(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.triangleSubdivisionRule).getValue<Token>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  size_t
  MeshPrim::getNumVerts() const
  {
    Attribute faceverts;
    if (getAttr(GeomTokens.faceVertexIndices, faceverts))
      return faceverts.getArraySize();
    return 0;
  }

  size_t
  MeshPrim::getNumFaces() const
  {
    Attribute facecounts;
    if (getAttr(GeomTokens.faceVertexCounts, facecounts)) {
      return facecounts.getArraySize();
    }
    return 0;
  }

}

#include "usg/geom/GprimPrim.h"

namespace usg {
  /*! Build facevert counts and point indices lists, returning number of faces.

  */
  /*virtual*/ size_t
  MeshPrim::getFaceVerts(const fdk::TimeValue& time,
                         Int32Array&           faceVertexCounts,
                         Int32Array&           faceVertexIndices,
                         bool*                 winding_is_clockwise) const
  {
    Prim::getAttr(GeomTokens.faceVertexCounts).getValue(faceVertexCounts);
    const size_t nFaces = faceVertexCounts.size();
    if (nFaces == 0) {
      return 0; // no mesh!
    }

    getFaceVertexIndicesAttr().getValue(faceVertexIndices);
    const size_t nVerts = faceVertexIndices.size();
    if (nVerts == 0) {
      return 0; // no mesh!
    }

    // Retrieve face winding order:
    if (winding_is_clockwise) {
      std::string orientation;
      GeometryPrim::getOrientationAttr().getValue(orientation);
      *winding_is_clockwise = (orientation == "leftHanded");
    }

    return nFaces;
  }
  // --(END CUSTOM CODE)--
}
