// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/MotionAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  MotionAPI::MotionAPI() : _prim() {}
  MotionAPI::MotionAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  MotionAPI::~MotionAPI() {}

  bool MotionAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = MotionAPI();
      return false;
    }
    return true;
  }

  bool MotionAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(GeomTokens.types.MotionAPI);
  }
  
  void MotionAPI::apply() {
    _prim.addAppliedSchema(GeomTokens.types.MotionAPI);
  }

  Attribute MotionAPI::createBlurScaleAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.motionBlurScale, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MotionAPI::getBlurScaleAttr() const {
    return _prim.getAttr(GeomTokens.motionBlurScale);
  }
  void MotionAPI::setBlurScale(float value, fdk::TimeValue time) {
    createBlurScaleAttr().setValue(value, time);
  }
  float MotionAPI::getBlurScale(fdk::TimeValue time) const {
    float v; _prim.getAttr(GeomTokens.motionBlurScale).getValue<float>(v, time); return v;
  }

  Attribute MotionAPI::createNonlinearSampleCountAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.motionNonlinearSampleCount, Value::Int, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MotionAPI::getNonlinearSampleCountAttr() const {
    return _prim.getAttr(GeomTokens.motionNonlinearSampleCount);
  }
  void MotionAPI::setNonlinearSampleCount(int value, fdk::TimeValue time) {
    createNonlinearSampleCountAttr().setValue(value, time);
  }
  int MotionAPI::getNonlinearSampleCount(fdk::TimeValue time) const {
    int v; _prim.getAttr(GeomTokens.motionNonlinearSampleCount).getValue<int>(v, time); return v;
  }

  Attribute MotionAPI::createVelocityScaleAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.motionVelocityScale, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute MotionAPI::getVelocityScaleAttr() const {
    return _prim.getAttr(GeomTokens.motionVelocityScale);
  }
  void MotionAPI::setVelocityScale(float value, fdk::TimeValue time) {
    createVelocityScaleAttr().setValue(value, time);
  }
  float MotionAPI::getVelocityScale(fdk::TimeValue time) const {
    float v; _prim.getAttr(GeomTokens.motionVelocityScale).getValue<float>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
