// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/NurbsCurvesPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  NurbsCurvesPrim::NurbsCurvesPrim() : CurvesPrim() {}
  NurbsCurvesPrim::NurbsCurvesPrim(const Prim& prim) : CurvesPrim(prim) {
    validate();
  }
  NurbsCurvesPrim::~NurbsCurvesPrim() {}

  bool NurbsCurvesPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = NurbsCurvesPrim();
      return false;
    }
    return true;
  }

  bool NurbsCurvesPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.NurbsCurves);
  }
  
  NurbsCurvesPrim NurbsCurvesPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? NurbsCurvesPrim(layer->definePrim(path, GeomTokens.types.NurbsCurves)) : NurbsCurvesPrim();
  }

  NurbsCurvesPrim NurbsCurvesPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? NurbsCurvesPrim(layer->overridePrim(prim)) : NurbsCurvesPrim();
  }

  NurbsCurvesPrim NurbsCurvesPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return NurbsCurvesPrim(stage->getPrimAtPath(path));
  }

  Attribute NurbsCurvesPrim::createKnotsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.knots, Value::DoubleArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsCurvesPrim::getKnotsAttr() const {
    return getAttr(GeomTokens.knots);
  }
  void NurbsCurvesPrim::setKnots(const DoubleArray& value, fdk::TimeValue time) {
    createKnotsAttr().setValue(value, time);
  }
  DoubleArray NurbsCurvesPrim::getKnots(fdk::TimeValue time) const {
    DoubleArray v; getAttr(GeomTokens.knots).getValue<DoubleArray>(v, time); return v;
  }

  Attribute NurbsCurvesPrim::createOrderAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.order, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsCurvesPrim::getOrderAttr() const {
    return getAttr(GeomTokens.order);
  }
  void NurbsCurvesPrim::setOrder(const IntArray& value, fdk::TimeValue time) {
    createOrderAttr().setValue(value, time);
  }
  IntArray NurbsCurvesPrim::getOrder(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.order).getValue<IntArray>(v, time); return v;
  }

  Attribute NurbsCurvesPrim::createRangesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.ranges, Value::Double2Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsCurvesPrim::getRangesAttr() const {
    return getAttr(GeomTokens.ranges);
  }
  void NurbsCurvesPrim::setRanges(const Vec2dArray& value, fdk::TimeValue time) {
    createRangesAttr().setValue(value, time);
  }
  Vec2dArray NurbsCurvesPrim::getRanges(fdk::TimeValue time) const {
    Vec2dArray v; getAttr(GeomTokens.ranges).getValue<Vec2dArray>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
