// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/NurbsPatchPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  NurbsPatchPrim::NurbsPatchPrim() : PointBasedPrim() {}
  NurbsPatchPrim::NurbsPatchPrim(const Prim& prim) : PointBasedPrim(prim) {
    validate();
  }
  NurbsPatchPrim::~NurbsPatchPrim() {}

  bool NurbsPatchPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = NurbsPatchPrim();
      return false;
    }
    return true;
  }

  bool NurbsPatchPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.NurbsPatch);
  }
  
  NurbsPatchPrim NurbsPatchPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? NurbsPatchPrim(layer->definePrim(path, GeomTokens.types.NurbsPatch)) : NurbsPatchPrim();
  }

  NurbsPatchPrim NurbsPatchPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? NurbsPatchPrim(layer->overridePrim(prim)) : NurbsPatchPrim();
  }

  NurbsPatchPrim NurbsPatchPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return NurbsPatchPrim(stage->getPrimAtPath(path));
  }

  Attribute NurbsPatchPrim::createPointWeightsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.pointWeights, Value::DoubleArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getPointWeightsAttr() const {
    return getAttr(GeomTokens.pointWeights);
  }
  void NurbsPatchPrim::setPointWeights(const DoubleArray& value, fdk::TimeValue time) {
    createPointWeightsAttr().setValue(value, time);
  }
  DoubleArray NurbsPatchPrim::getPointWeights(fdk::TimeValue time) const {
    DoubleArray v; getAttr(GeomTokens.pointWeights).getValue<DoubleArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createCountsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.trimCurveCounts, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getCountsAttr() const {
    return getAttr(GeomTokens.trimCurveCounts);
  }
  void NurbsPatchPrim::setCounts(const IntArray& value, fdk::TimeValue time) {
    createCountsAttr().setValue(value, time);
  }
  IntArray NurbsPatchPrim::getCounts(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.trimCurveCounts).getValue<IntArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createKnotsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.trimCurveKnots, Value::DoubleArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getKnotsAttr() const {
    return getAttr(GeomTokens.trimCurveKnots);
  }
  void NurbsPatchPrim::setKnots(const DoubleArray& value, fdk::TimeValue time) {
    createKnotsAttr().setValue(value, time);
  }
  DoubleArray NurbsPatchPrim::getKnots(fdk::TimeValue time) const {
    DoubleArray v; getAttr(GeomTokens.trimCurveKnots).getValue<DoubleArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createOrdersAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.trimCurveOrders, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getOrdersAttr() const {
    return getAttr(GeomTokens.trimCurveOrders);
  }
  void NurbsPatchPrim::setOrders(const IntArray& value, fdk::TimeValue time) {
    createOrdersAttr().setValue(value, time);
  }
  IntArray NurbsPatchPrim::getOrders(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.trimCurveOrders).getValue<IntArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createPointsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.trimCurvePoints, Value::Double3Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getPointsAttr() const {
    return getAttr(GeomTokens.trimCurvePoints);
  }
  void NurbsPatchPrim::setPoints(const Vec3dArray& value, fdk::TimeValue time) {
    createPointsAttr().setValue(value, time);
  }
  Vec3dArray NurbsPatchPrim::getPoints(fdk::TimeValue time) const {
    Vec3dArray v; getAttr(GeomTokens.trimCurvePoints).getValue<Vec3dArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createRangesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.trimCurveRanges, Value::Double2Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getRangesAttr() const {
    return getAttr(GeomTokens.trimCurveRanges);
  }
  void NurbsPatchPrim::setRanges(const Vec2dArray& value, fdk::TimeValue time) {
    createRangesAttr().setValue(value, time);
  }
  Vec2dArray NurbsPatchPrim::getRanges(fdk::TimeValue time) const {
    Vec2dArray v; getAttr(GeomTokens.trimCurveRanges).getValue<Vec2dArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createVertexCountsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.trimCurveVertexCounts, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getVertexCountsAttr() const {
    return getAttr(GeomTokens.trimCurveVertexCounts);
  }
  void NurbsPatchPrim::setVertexCounts(const IntArray& value, fdk::TimeValue time) {
    createVertexCountsAttr().setValue(value, time);
  }
  IntArray NurbsPatchPrim::getVertexCounts(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.trimCurveVertexCounts).getValue<IntArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createUFormAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.uForm, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute NurbsPatchPrim::getUFormAttr() const {
    return getAttr(GeomTokens.uForm);
  }
  void NurbsPatchPrim::setUForm(const Token& value, fdk::TimeValue time) {
    createUFormAttr().setValue(value, time);
  }
  Token NurbsPatchPrim::getUForm(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.uForm).getValue<Token>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createUKnotsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.uKnots, Value::DoubleArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getUKnotsAttr() const {
    return getAttr(GeomTokens.uKnots);
  }
  void NurbsPatchPrim::setUKnots(const DoubleArray& value, fdk::TimeValue time) {
    createUKnotsAttr().setValue(value, time);
  }
  DoubleArray NurbsPatchPrim::getUKnots(fdk::TimeValue time) const {
    DoubleArray v; getAttr(GeomTokens.uKnots).getValue<DoubleArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createUOrderAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.uOrder, Value::Int, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getUOrderAttr() const {
    return getAttr(GeomTokens.uOrder);
  }
  void NurbsPatchPrim::setUOrder(int value, fdk::TimeValue time) {
    createUOrderAttr().setValue(value, time);
  }
  int NurbsPatchPrim::getUOrder(fdk::TimeValue time) const {
    int v; getAttr(GeomTokens.uOrder).getValue<int>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createURangeAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.uRange, Value::Double2, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getURangeAttr() const {
    return getAttr(GeomTokens.uRange);
  }
  void NurbsPatchPrim::setURange(const fdk::Vec2d& value, fdk::TimeValue time) {
    createURangeAttr().setValue(value, time);
  }
  fdk::Vec2d NurbsPatchPrim::getURange(fdk::TimeValue time) const {
    fdk::Vec2d v; getAttr(GeomTokens.uRange).getValue<fdk::Vec2d>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createUVertexCountAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.uVertexCount, Value::Int, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getUVertexCountAttr() const {
    return getAttr(GeomTokens.uVertexCount);
  }
  void NurbsPatchPrim::setUVertexCount(int value, fdk::TimeValue time) {
    createUVertexCountAttr().setValue(value, time);
  }
  int NurbsPatchPrim::getUVertexCount(fdk::TimeValue time) const {
    int v; getAttr(GeomTokens.uVertexCount).getValue<int>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createVFormAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.vForm, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute NurbsPatchPrim::getVFormAttr() const {
    return getAttr(GeomTokens.vForm);
  }
  void NurbsPatchPrim::setVForm(const Token& value, fdk::TimeValue time) {
    createVFormAttr().setValue(value, time);
  }
  Token NurbsPatchPrim::getVForm(fdk::TimeValue time) const {
    Token v; getAttr(GeomTokens.vForm).getValue<Token>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createVKnotsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.vKnots, Value::DoubleArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getVKnotsAttr() const {
    return getAttr(GeomTokens.vKnots);
  }
  void NurbsPatchPrim::setVKnots(const DoubleArray& value, fdk::TimeValue time) {
    createVKnotsAttr().setValue(value, time);
  }
  DoubleArray NurbsPatchPrim::getVKnots(fdk::TimeValue time) const {
    DoubleArray v; getAttr(GeomTokens.vKnots).getValue<DoubleArray>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createVOrderAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.vOrder, Value::Int, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getVOrderAttr() const {
    return getAttr(GeomTokens.vOrder);
  }
  void NurbsPatchPrim::setVOrder(int value, fdk::TimeValue time) {
    createVOrderAttr().setValue(value, time);
  }
  int NurbsPatchPrim::getVOrder(fdk::TimeValue time) const {
    int v; getAttr(GeomTokens.vOrder).getValue<int>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createVRangeAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.vRange, Value::Double2, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getVRangeAttr() const {
    return getAttr(GeomTokens.vRange);
  }
  void NurbsPatchPrim::setVRange(const fdk::Vec2d& value, fdk::TimeValue time) {
    createVRangeAttr().setValue(value, time);
  }
  fdk::Vec2d NurbsPatchPrim::getVRange(fdk::TimeValue time) const {
    fdk::Vec2d v; getAttr(GeomTokens.vRange).getValue<fdk::Vec2d>(v, time); return v;
  }

  Attribute NurbsPatchPrim::createVVertexCountAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.vVertexCount, Value::Int, false, TimeVariability::Varying, defaultValue);
  }
  Attribute NurbsPatchPrim::getVVertexCountAttr() const {
    return getAttr(GeomTokens.vVertexCount);
  }
  void NurbsPatchPrim::setVVertexCount(int value, fdk::TimeValue time) {
    createVVertexCountAttr().setValue(value, time);
  }
  int NurbsPatchPrim::getVVertexCount(fdk::TimeValue time) const {
    int v; getAttr(GeomTokens.vVertexCount).getValue<int>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
