// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/PointBasedPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  PointBasedPrim::PointBasedPrim() : GprimPrim() {}
  PointBasedPrim::PointBasedPrim(const Prim& prim) : GprimPrim(prim) {
    validate();
  }
  PointBasedPrim::~PointBasedPrim() {}

  bool PointBasedPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = PointBasedPrim();
      return false;
    }
    return true;
  }

  bool PointBasedPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.PointBased);
  }
  

  PointBasedPrim PointBasedPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? PointBasedPrim(layer->overridePrim(prim)) : PointBasedPrim();
  }

  PointBasedPrim PointBasedPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return PointBasedPrim(stage->getPrimAtPath(path));
  }

  Attribute PointBasedPrim::createAccelerationsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.accelerations, Value::Vector3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointBasedPrim::getAccelerationsAttr() const {
    return getAttr(GeomTokens.accelerations);
  }
  void PointBasedPrim::setAccelerations(const Vec3fArray& value, fdk::TimeValue time) {
    createAccelerationsAttr().setValue(value, time);
  }
  Vec3fArray PointBasedPrim::getAccelerations(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.accelerations).getValue<Vec3fArray>(v, time); return v;
  }

  Attribute PointBasedPrim::createNormalsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.normals, Value::Normal3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointBasedPrim::getNormalsAttr() const {
    return getAttr(GeomTokens.normals);
  }
  void PointBasedPrim::setNormals(const Vec3fArray& value, fdk::TimeValue time) {
    createNormalsAttr().setValue(value, time);
  }
  Vec3fArray PointBasedPrim::getNormals(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.normals).getValue<Vec3fArray>(v, time); return v;
  }

  Attribute PointBasedPrim::createPointsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.points, Value::Point3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointBasedPrim::getPointsAttr() const {
    return getAttr(GeomTokens.points);
  }
  void PointBasedPrim::setPoints(const Vec3fArray& value, fdk::TimeValue time) {
    createPointsAttr().setValue(value, time);
  }
  Vec3fArray PointBasedPrim::getPoints(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.points).getValue<Vec3fArray>(v, time); return v;
  }

  Attribute PointBasedPrim::createVelocitiesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.velocities, Value::Vector3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointBasedPrim::getVelocitiesAttr() const {
    return getAttr(GeomTokens.velocities);
  }
  void PointBasedPrim::setVelocities(const Vec3fArray& value, fdk::TimeValue time) {
    createVelocitiesAttr().setValue(value, time);
  }
  Vec3fArray PointBasedPrim::getVelocities(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.velocities).getValue<Vec3fArray>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
}

namespace usg {

  size_t
  PointBasedPrim::getPointsArray(Vec3fArray&           points,
                                 const fdk::TimeValue& time) const
  {
    if (Attribute attr = getPointsAttr()) {
      attr.getValue(points, time);
      return points.size();
    }
    points.clear();
    return 0;
  }

  Attribute PointBasedPrim::setNormalsAttr(const Vec3fArray&     normals,
                                           const Token&          interpolation,
                                           const fdk::TimeValue& time)
  {
    auto attr = createAttr(GeomTokens.primvarsNormals, Value::Normal3fArray, false, TimeVariability::Varying);
    attr.setValue(normals, time);
    attr.setInterpolation(interpolation);
    return attr;
  }

  Attribute PointBasedPrim::setStAttr(const Vec2fArray&     st,
                                      const Token&          interpolation,
                                      const fdk::TimeValue& time)
  {
    auto attr = createAttr(GeomTokens.primvarsSt, Value::TexCoord2fArray, false, TimeVariability::Varying);
    attr.setValue(st, time);
    attr.setInterpolation(interpolation);
    return attr;
  }

  Attribute PointBasedPrim::getStAttr() const
  {
    return Prim::getAttr(GeomTokens.primvarsSt);
  }
  // --(END CUSTOM CODE)--
}
