// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/PointInstancerPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  PointInstancerPrim::PointInstancerPrim() : BoundablePrim() {}
  PointInstancerPrim::PointInstancerPrim(const Prim& prim) : BoundablePrim(prim) {
    validate();
  }
  PointInstancerPrim::~PointInstancerPrim() {}

  bool PointInstancerPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = PointInstancerPrim();
      return false;
    }
    return true;
  }

  bool PointInstancerPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.PointInstancer);
  }
  
  PointInstancerPrim PointInstancerPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? PointInstancerPrim(layer->definePrim(path, GeomTokens.types.PointInstancer)) : PointInstancerPrim();
  }

  PointInstancerPrim PointInstancerPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? PointInstancerPrim(layer->overridePrim(prim)) : PointInstancerPrim();
  }

  PointInstancerPrim PointInstancerPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return PointInstancerPrim(stage->getPrimAtPath(path));
  }

  Attribute PointInstancerPrim::createAccelerationsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.accelerations, Value::Vector3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getAccelerationsAttr() const {
    return getAttr(GeomTokens.accelerations);
  }
  void PointInstancerPrim::setAccelerations(const Vec3fArray& value, fdk::TimeValue time) {
    createAccelerationsAttr().setValue(value, time);
  }
  Vec3fArray PointInstancerPrim::getAccelerations(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.accelerations).getValue<Vec3fArray>(v, time); return v;
  }

  Attribute PointInstancerPrim::createAngularVelocitiesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.angularVelocities, Value::Vector3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getAngularVelocitiesAttr() const {
    return getAttr(GeomTokens.angularVelocities);
  }
  void PointInstancerPrim::setAngularVelocities(const Vec3fArray& value, fdk::TimeValue time) {
    createAngularVelocitiesAttr().setValue(value, time);
  }
  Vec3fArray PointInstancerPrim::getAngularVelocities(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.angularVelocities).getValue<Vec3fArray>(v, time); return v;
  }

  Attribute PointInstancerPrim::createIdsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.ids, Value::Int64Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getIdsAttr() const {
    return getAttr(GeomTokens.ids);
  }
  void PointInstancerPrim::setIds(const Int64Array& value, fdk::TimeValue time) {
    createIdsAttr().setValue(value, time);
  }
  Int64Array PointInstancerPrim::getIds(fdk::TimeValue time) const {
    Int64Array v; getAttr(GeomTokens.ids).getValue<Int64Array>(v, time); return v;
  }

  Attribute PointInstancerPrim::createInvisibleIdsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.invisibleIds, Value::Int64Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getInvisibleIdsAttr() const {
    return getAttr(GeomTokens.invisibleIds);
  }
  void PointInstancerPrim::setInvisibleIds(const Int64Array& value, fdk::TimeValue time) {
    createInvisibleIdsAttr().setValue(value, time);
  }
  Int64Array PointInstancerPrim::getInvisibleIds(fdk::TimeValue time) const {
    Int64Array v; getAttr(GeomTokens.invisibleIds).getValue<Int64Array>(v, time); return v;
  }

  Attribute PointInstancerPrim::createOrientationsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.orientations, Value::QuathArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getOrientationsAttr() const {
    return getAttr(GeomTokens.orientations);
  }
  void PointInstancerPrim::setOrientations(const QuathArray& value, fdk::TimeValue time) {
    createOrientationsAttr().setValue(value, time);
  }
  QuathArray PointInstancerPrim::getOrientations(fdk::TimeValue time) const {
    QuathArray v; getAttr(GeomTokens.orientations).getValue<QuathArray>(v, time); return v;
  }

  Attribute PointInstancerPrim::createPositionsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.positions, Value::Point3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getPositionsAttr() const {
    return getAttr(GeomTokens.positions);
  }
  void PointInstancerPrim::setPositions(const Vec3fArray& value, fdk::TimeValue time) {
    createPositionsAttr().setValue(value, time);
  }
  Vec3fArray PointInstancerPrim::getPositions(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.positions).getValue<Vec3fArray>(v, time); return v;
  }

  Attribute PointInstancerPrim::createProtoIndicesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.protoIndices, Value::IntArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getProtoIndicesAttr() const {
    return getAttr(GeomTokens.protoIndices);
  }
  void PointInstancerPrim::setProtoIndices(const IntArray& value, fdk::TimeValue time) {
    createProtoIndicesAttr().setValue(value, time);
  }
  IntArray PointInstancerPrim::getProtoIndices(fdk::TimeValue time) const {
    IntArray v; getAttr(GeomTokens.protoIndices).getValue<IntArray>(v, time); return v;
  }

  Relationship PointInstancerPrim::createPrototypesRel() {
    return createRelationship(GeomTokens.prototypes);
  }
  Relationship PointInstancerPrim::getPrototypesRel() const {
    return getRelationship(GeomTokens.prototypes);
  }
  void PointInstancerPrim::setPrototypes(const PathArray& value, fdk::TimeValue time) {
    createRelationship(GeomTokens.prototypes).setTargets(value);
  }
  PathArray PointInstancerPrim::getPrototypes(fdk::TimeValue time) const {
    return getRelationship(GeomTokens.prototypes).getTargets();
  }

  Attribute PointInstancerPrim::createScalesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.scales, Value::Float3Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getScalesAttr() const {
    return getAttr(GeomTokens.scales);
  }
  void PointInstancerPrim::setScales(const Vec3fArray& value, fdk::TimeValue time) {
    createScalesAttr().setValue(value, time);
  }
  Vec3fArray PointInstancerPrim::getScales(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.scales).getValue<Vec3fArray>(v, time); return v;
  }

  Attribute PointInstancerPrim::createVelocitiesAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.velocities, Value::Vector3fArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointInstancerPrim::getVelocitiesAttr() const {
    return getAttr(GeomTokens.velocities);
  }
  void PointInstancerPrim::setVelocities(const Vec3fArray& value, fdk::TimeValue time) {
    createVelocitiesAttr().setValue(value, time);
  }
  Vec3fArray PointInstancerPrim::getVelocities(fdk::TimeValue time) const {
    Vec3fArray v; getAttr(GeomTokens.velocities).getValue<Vec3fArray>(v, time); return v;
  }

  // --(BEGIN CUSTOM CODE)--
}

#include "usg/private/UsdImpl.h"

namespace usg {
  fdk::Box3f PointInstancerPrim::computeExtentAtTime(fdk::TimeValue time, fdk::TimeValue baseTime) const
  {
    if (_pImpl->usdprim) {
      PXR_NS::VtVec3fArray extent;
      PXR_NS::UsdGeomPointInstancer pointInstancer(_pImpl->usdprim);
      pointInstancer.ComputeExtentAtTime(&extent, time, baseTime);
      return fdk::Box3f(reinterpret_cast<const fdk::Vec3f&>(extent[0]), reinterpret_cast<const fdk::Vec3f&>(extent[1]));
    }
    return fdk::Box3f();
  }
  // --(END CUSTOM CODE)--
}
