// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/PointsPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  PointsPrim::PointsPrim() : PointBasedPrim() {}
  PointsPrim::PointsPrim(const Prim& prim) : PointBasedPrim(prim) {
    validate();
  }
  PointsPrim::~PointsPrim() {}

  bool PointsPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = PointsPrim();
      return false;
    }
    return true;
  }

  bool PointsPrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Points);
  }
  
  PointsPrim PointsPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? PointsPrim(layer->definePrim(path, GeomTokens.types.Points)) : PointsPrim();
  }

  PointsPrim PointsPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? PointsPrim(layer->overridePrim(prim)) : PointsPrim();
  }

  PointsPrim PointsPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return PointsPrim(stage->getPrimAtPath(path));
  }

  Attribute PointsPrim::createIdsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.ids, Value::Int64Array, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointsPrim::getIdsAttr() const {
    return getAttr(GeomTokens.ids);
  }
  void PointsPrim::setIds(const Int64Array& value, fdk::TimeValue time) {
    createIdsAttr().setValue(value, time);
  }
  Int64Array PointsPrim::getIds(fdk::TimeValue time) const {
    Int64Array v; getAttr(GeomTokens.ids).getValue<Int64Array>(v, time); return v;
  }

  Attribute PointsPrim::createWidthsAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.widths, Value::FloatArray, false, TimeVariability::Varying, defaultValue);
  }
  Attribute PointsPrim::getWidthsAttr() const {
    return getAttr(GeomTokens.widths);
  }
  void PointsPrim::setWidths(const FloatArray& value, fdk::TimeValue time) {
    createWidthsAttr().setValue(value, time);
  }
  FloatArray PointsPrim::getWidths(fdk::TimeValue time) const {
    FloatArray v; getAttr(GeomTokens.widths).getValue<FloatArray>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
