// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

#include "usg/geom/ShaderSchema.h"

#include "usg/private/UsdImpl.h"

namespace usg
{
/*! This ctor should only get called once from the Parse() method for each
    subclass that wants to register itself.
*/
ShaderSchema::ShaderSchema(const SchemaDescription&   pluginDescription,
                           const ShaderPropertyArray& properties,
                           const fdk::KeyValueMap&    metadata) :
  usg::Schema(pluginDescription, properties, metadata)
{
  //
}


/*virtual*/ const std::string&
ShaderSchema::sourceCode(const Token& sourceType) const
{
  return empty_string;
}

const bool ShaderSchema::sourceCode(ShaderSource& shaderSource) const { return false; }

const ShaderPropertyArray& ShaderSchema::shaderProperties() const
{
  static const ShaderPropertyArray emptyPropertyArray;
  return emptyPropertyArray;
}


//------------------------------------------------------------------------------------


CoShaderSchema::CoShaderSchema(const SchemaDescription&   pluginDescription,
                               const ShaderPropertyArray& properties,
                               const fdk::KeyValueMap&    metadata) :
  ShaderSchema(pluginDescription, properties, metadata)
{
  //
}


//------------------------------------------------------------------------------------


SurfaceShaderSchema::SurfaceShaderSchema(const SchemaDescription&   pluginDescription,
                                         const ShaderPropertyArray& properties,
                                         const fdk::KeyValueMap&    metadata) :
  ShaderSchema(pluginDescription, properties, metadata)
{
  //
}


//------------------------------------------------------------------------------------


LightShaderSchema::LightShaderSchema(const SchemaDescription&   pluginDescription,
                                     const ShaderPropertyArray& properties,
                                     const fdk::KeyValueMap&    metadata) :
  ShaderSchema(pluginDescription, properties, metadata)
{
  //
}


} // namespace usg
