// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/SpherePrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  SpherePrim::SpherePrim() : GprimPrim() {}
  SpherePrim::SpherePrim(const Prim& prim) : GprimPrim(prim) {
    validate();
  }
  SpherePrim::~SpherePrim() {}

  bool SpherePrim::validate() {
    if (!isValidPrim(*this)) {
      *this = SpherePrim();
      return false;
    }
    return true;
  }

  bool SpherePrim::isValidPrim(const Prim& prim) {
    return prim.isA(GeomTokens.types.Sphere);
  }
  
  SpherePrim SpherePrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? SpherePrim(layer->definePrim(path, GeomTokens.types.Sphere)) : SpherePrim();
  }

  SpherePrim SpherePrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? SpherePrim(layer->overridePrim(prim)) : SpherePrim();
  }

  SpherePrim SpherePrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return SpherePrim(stage->getPrimAtPath(path));
  }

  Attribute SpherePrim::createRadiusAttr(const Value& defaultValue) {
    return createAttr(GeomTokens.radius, Value::Double, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SpherePrim::getRadiusAttr() const {
    return getAttr(GeomTokens.radius);
  }
  void SpherePrim::setRadius(double value, fdk::TimeValue time) {
    createRadiusAttr().setValue(value, time);
  }
  double SpherePrim::getRadius(fdk::TimeValue time) const {
    double v; getAttr(GeomTokens.radius).getValue<double>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
