// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

#include "usg/api.h"

#include "pxr/usd/kind/registry.h"
#include "pxr/usd/usdGeom/imageable.h"

#include <vector>

namespace usg {

  USG_API const char** KindNames()
  {
    // EnumerationKnob desperately needs a modern API
    static std::vector<const char*> sKindNames;
    if (sKindNames.size() == 0) {
      for (const auto t : PXR_NS::KindRegistry::GetInstance().GetAllKinds()) {
        sKindNames.push_back(t.GetText());
      }
      sKindNames.push_back(nullptr);
    }
    return sKindNames.data();
  }

  USG_API const char** PurposeNames()
  {
    // EnumerationKnob desperately needs a modern API
    static std::vector<const char*> sPurposeNames;
    if (sPurposeNames.size() == 0) {
      for (const auto t : PXR_NS::UsdGeomImageable::GetOrderedPurposeTokens()) {
        sPurposeNames.push_back(t.GetText());
      }
      sPurposeNames.push_back(nullptr);
    }
    return sPurposeNames.data();
  }

}
