// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/geom/VisibilityAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {

  VisibilityAPI::VisibilityAPI() : _prim() {}
  VisibilityAPI::VisibilityAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  VisibilityAPI::~VisibilityAPI() {}

  bool VisibilityAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = VisibilityAPI();
      return false;
    }
    return true;
  }

  bool VisibilityAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(GeomTokens.types.VisibilityAPI);
  }
  
  void VisibilityAPI::apply() {
    _prim.addAppliedSchema(GeomTokens.types.VisibilityAPI);
  }

  Attribute VisibilityAPI::createGuideVisibilityAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.guideVisibility, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute VisibilityAPI::getGuideVisibilityAttr() const {
    return _prim.getAttr(GeomTokens.guideVisibility);
  }
  void VisibilityAPI::setGuideVisibility(const Token& value, fdk::TimeValue time) {
    createGuideVisibilityAttr().setValue(value, time);
  }
  Token VisibilityAPI::getGuideVisibility(fdk::TimeValue time) const {
    Token v; _prim.getAttr(GeomTokens.guideVisibility).getValue<Token>(v, time); return v;
  }

  Attribute VisibilityAPI::createProxyVisibilityAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.proxyVisibility, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute VisibilityAPI::getProxyVisibilityAttr() const {
    return _prim.getAttr(GeomTokens.proxyVisibility);
  }
  void VisibilityAPI::setProxyVisibility(const Token& value, fdk::TimeValue time) {
    createProxyVisibilityAttr().setValue(value, time);
  }
  Token VisibilityAPI::getProxyVisibility(fdk::TimeValue time) const {
    Token v; _prim.getAttr(GeomTokens.proxyVisibility).getValue<Token>(v, time); return v;
  }

  Attribute VisibilityAPI::createRenderVisibilityAttr(const Value& defaultValue) {
    return _prim.createAttr(GeomTokens.renderVisibility, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute VisibilityAPI::getRenderVisibilityAttr() const {
    return _prim.getAttr(GeomTokens.renderVisibility);
  }
  void VisibilityAPI::setRenderVisibility(const Token& value, fdk::TimeValue time) {
    createRenderVisibilityAttr().setValue(value, time);
  }
  Token VisibilityAPI::getRenderVisibility(fdk::TimeValue time) const {
    Token v; _prim.getAttr(GeomTokens.renderVisibility).getValue<Token>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
