// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/CylinderLightPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  CylinderLightPrim::CylinderLightPrim() : BoundableLightBasePrim() {}
  CylinderLightPrim::CylinderLightPrim(const Prim& prim) : BoundableLightBasePrim(prim) {
    validate();
  }
  CylinderLightPrim::~CylinderLightPrim() {}

  bool CylinderLightPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = CylinderLightPrim();
      return false;
    }
    return true;
  }

  bool CylinderLightPrim::isValidPrim(const Prim& prim) {
    return prim.isA(LuxTokens.types.CylinderLight);
  }
  
  CylinderLightPrim CylinderLightPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? CylinderLightPrim(layer->definePrim(path, LuxTokens.types.CylinderLight)) : CylinderLightPrim();
  }

  CylinderLightPrim CylinderLightPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? CylinderLightPrim(layer->overridePrim(prim)) : CylinderLightPrim();
  }

  CylinderLightPrim CylinderLightPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return CylinderLightPrim(stage->getPrimAtPath(path));
  }

  Relationship CylinderLightPrim::createFiltersRel() {
    return createRelationship(LuxTokens.filters);
  }
  Relationship CylinderLightPrim::getFiltersRel() const {
    return getRelationship(LuxTokens.filters);
  }
  void CylinderLightPrim::setFilters(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.filters).setTargets(value);
  }
  PathArray CylinderLightPrim::getFilters(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.filters).getTargets();
  }

  Attribute CylinderLightPrim::createColorAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColor, Value::Color3f, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getColorAttr() const {
    return getAttr(LuxTokens.inputsColor);
  }
  void CylinderLightPrim::setColor(const fdk::Vec3f& value, fdk::TimeValue time) {
    createColorAttr().setValue(value, time);
  }
  fdk::Vec3f CylinderLightPrim::getColor(fdk::TimeValue time) const {
    fdk::Vec3f v; getAttr(LuxTokens.inputsColor).getValue<fdk::Vec3f>(v, time); return v;
  }

  Attribute CylinderLightPrim::createColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColorTemperature, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsColorTemperature);
  }
  void CylinderLightPrim::setColorTemperature(float value, fdk::TimeValue time) {
    createColorTemperatureAttr().setValue(value, time);
  }
  float CylinderLightPrim::getColorTemperature(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsColorTemperature).getValue<float>(v, time); return v;
  }

  Attribute CylinderLightPrim::createDiffuseAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsDiffuse, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getDiffuseAttr() const {
    return getAttr(LuxTokens.inputsDiffuse);
  }
  void CylinderLightPrim::setDiffuse(float value, fdk::TimeValue time) {
    createDiffuseAttr().setValue(value, time);
  }
  float CylinderLightPrim::getDiffuse(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsDiffuse).getValue<float>(v, time); return v;
  }

  Attribute CylinderLightPrim::createEnableColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsEnableColorTemperature, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getEnableColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsEnableColorTemperature);
  }
  void CylinderLightPrim::setEnableColorTemperature(bool value, fdk::TimeValue time) {
    createEnableColorTemperatureAttr().setValue(value, time);
  }
  bool CylinderLightPrim::getEnableColorTemperature(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsEnableColorTemperature).getValue<bool>(v, time); return v;
  }

  Attribute CylinderLightPrim::createExposureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsExposure, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getExposureAttr() const {
    return getAttr(LuxTokens.inputsExposure);
  }
  void CylinderLightPrim::setExposure(float value, fdk::TimeValue time) {
    createExposureAttr().setValue(value, time);
  }
  float CylinderLightPrim::getExposure(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsExposure).getValue<float>(v, time); return v;
  }

  Attribute CylinderLightPrim::createIntensityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsIntensity, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getIntensityAttr() const {
    return getAttr(LuxTokens.inputsIntensity);
  }
  void CylinderLightPrim::setIntensity(float value, fdk::TimeValue time) {
    createIntensityAttr().setValue(value, time);
  }
  float CylinderLightPrim::getIntensity(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsIntensity).getValue<float>(v, time); return v;
  }

  Attribute CylinderLightPrim::createLengthAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsLength, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getLengthAttr() const {
    return getAttr(LuxTokens.inputsLength);
  }
  void CylinderLightPrim::setLength(float value, fdk::TimeValue time) {
    createLengthAttr().setValue(value, time);
  }
  float CylinderLightPrim::getLength(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsLength).getValue<float>(v, time); return v;
  }

  Attribute CylinderLightPrim::createNormalizeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsNormalize, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getNormalizeAttr() const {
    return getAttr(LuxTokens.inputsNormalize);
  }
  void CylinderLightPrim::setNormalize(bool value, fdk::TimeValue time) {
    createNormalizeAttr().setValue(value, time);
  }
  bool CylinderLightPrim::getNormalize(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsNormalize).getValue<bool>(v, time); return v;
  }

  Attribute CylinderLightPrim::createRadiusAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsRadius, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getRadiusAttr() const {
    return getAttr(LuxTokens.inputsRadius);
  }
  void CylinderLightPrim::setRadius(float value, fdk::TimeValue time) {
    createRadiusAttr().setValue(value, time);
  }
  float CylinderLightPrim::getRadius(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsRadius).getValue<float>(v, time); return v;
  }

  Attribute CylinderLightPrim::createSpecularAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsSpecular, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getSpecularAttr() const {
    return getAttr(LuxTokens.inputsSpecular);
  }
  void CylinderLightPrim::setSpecular(float value, fdk::TimeValue time) {
    createSpecularAttr().setValue(value, time);
  }
  float CylinderLightPrim::getSpecular(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsSpecular).getValue<float>(v, time); return v;
  }

  Attribute CylinderLightPrim::createShaderIdAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.lightShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute CylinderLightPrim::getShaderIdAttr() const {
    return getAttr(LuxTokens.lightShaderId);
  }
  void CylinderLightPrim::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token CylinderLightPrim::getShaderId(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.lightShaderId).getValue<Token>(v, time); return v;
  }

  Relationship CylinderLightPrim::createProxyPrimRel() {
    return createRelationship(LuxTokens.proxyPrim);
  }
  Relationship CylinderLightPrim::getProxyPrimRel() const {
    return getRelationship(LuxTokens.proxyPrim);
  }
  void CylinderLightPrim::setProxyPrim(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.proxyPrim).setTargets(value);
  }
  PathArray CylinderLightPrim::getProxyPrim(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.proxyPrim).getTargets();
  }

  Attribute CylinderLightPrim::createPurposeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.purpose, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute CylinderLightPrim::getPurposeAttr() const {
    return getAttr(LuxTokens.purpose);
  }
  void CylinderLightPrim::setPurpose(const Token& value, fdk::TimeValue time) {
    createPurposeAttr().setValue(value, time);
  }
  Token CylinderLightPrim::getPurpose(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.purpose).getValue<Token>(v, time); return v;
  }

  Attribute CylinderLightPrim::createTreatAsLineAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.treatAsLine, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getTreatAsLineAttr() const {
    return getAttr(LuxTokens.treatAsLine);
  }
  void CylinderLightPrim::setTreatAsLine(bool value, fdk::TimeValue time) {
    createTreatAsLineAttr().setValue(value, time);
  }
  bool CylinderLightPrim::getTreatAsLine(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.treatAsLine).getValue<bool>(v, time); return v;
  }

  Attribute CylinderLightPrim::createVisibilityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.visibility, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute CylinderLightPrim::getVisibilityAttr() const {
    return getAttr(LuxTokens.visibility);
  }
  void CylinderLightPrim::setVisibility(const Token& value, fdk::TimeValue time) {
    createVisibilityAttr().setValue(value, time);
  }
  Token CylinderLightPrim::getVisibility(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.visibility).getValue<Token>(v, time); return v;
  }

  Attribute CylinderLightPrim::createXformOpOrderAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.xformOpOrder, Value::TokenArray, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute CylinderLightPrim::getXformOpOrderAttr() const {
    return getAttr(LuxTokens.xformOpOrder);
  }
  void CylinderLightPrim::setXformOpOrder(const TokenArray& value, fdk::TimeValue time) {
    createXformOpOrderAttr().setValue(value, time);
  }
  TokenArray CylinderLightPrim::getXformOpOrder(fdk::TimeValue time) const {
    TokenArray v; getAttr(LuxTokens.xformOpOrder).getValue<TokenArray>(v, time); return v;
  }

  usg::CollectionAPI CylinderLightPrim::getLightLink() const { return usg::CollectionAPI(*this, "lightLink"); }

  usg::CollectionAPI CylinderLightPrim::getShadowLink() const { return usg::CollectionAPI(*this, "shadowLink"); }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
