// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/DomeLightPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  DomeLightPrim::DomeLightPrim() : NonboundableLightBasePrim() {}
  DomeLightPrim::DomeLightPrim(const Prim& prim) : NonboundableLightBasePrim(prim) {
    validate();
  }
  DomeLightPrim::~DomeLightPrim() {}

  bool DomeLightPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = DomeLightPrim();
      return false;
    }
    return true;
  }

  bool DomeLightPrim::isValidPrim(const Prim& prim) {
    return prim.isA(LuxTokens.types.DomeLight);
  }
  
  DomeLightPrim DomeLightPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? DomeLightPrim(layer->definePrim(path, LuxTokens.types.DomeLight)) : DomeLightPrim();
  }

  DomeLightPrim DomeLightPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? DomeLightPrim(layer->overridePrim(prim)) : DomeLightPrim();
  }

  DomeLightPrim DomeLightPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return DomeLightPrim(stage->getPrimAtPath(path));
  }

  Relationship DomeLightPrim::createFiltersRel() {
    return createRelationship(LuxTokens.filters);
  }
  Relationship DomeLightPrim::getFiltersRel() const {
    return getRelationship(LuxTokens.filters);
  }
  void DomeLightPrim::setFilters(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.filters).setTargets(value);
  }
  PathArray DomeLightPrim::getFilters(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.filters).getTargets();
  }

  Attribute DomeLightPrim::createGuideRadiusAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.guideRadius, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getGuideRadiusAttr() const {
    return getAttr(LuxTokens.guideRadius);
  }
  void DomeLightPrim::setGuideRadius(float value, fdk::TimeValue time) {
    createGuideRadiusAttr().setValue(value, time);
  }
  float DomeLightPrim::getGuideRadius(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.guideRadius).getValue<float>(v, time); return v;
  }

  Attribute DomeLightPrim::createColorAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColor, Value::Color3f, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getColorAttr() const {
    return getAttr(LuxTokens.inputsColor);
  }
  void DomeLightPrim::setColor(const fdk::Vec3f& value, fdk::TimeValue time) {
    createColorAttr().setValue(value, time);
  }
  fdk::Vec3f DomeLightPrim::getColor(fdk::TimeValue time) const {
    fdk::Vec3f v; getAttr(LuxTokens.inputsColor).getValue<fdk::Vec3f>(v, time); return v;
  }

  Attribute DomeLightPrim::createColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColorTemperature, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsColorTemperature);
  }
  void DomeLightPrim::setColorTemperature(float value, fdk::TimeValue time) {
    createColorTemperatureAttr().setValue(value, time);
  }
  float DomeLightPrim::getColorTemperature(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsColorTemperature).getValue<float>(v, time); return v;
  }

  Attribute DomeLightPrim::createDiffuseAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsDiffuse, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getDiffuseAttr() const {
    return getAttr(LuxTokens.inputsDiffuse);
  }
  void DomeLightPrim::setDiffuse(float value, fdk::TimeValue time) {
    createDiffuseAttr().setValue(value, time);
  }
  float DomeLightPrim::getDiffuse(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsDiffuse).getValue<float>(v, time); return v;
  }

  Attribute DomeLightPrim::createEnableColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsEnableColorTemperature, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getEnableColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsEnableColorTemperature);
  }
  void DomeLightPrim::setEnableColorTemperature(bool value, fdk::TimeValue time) {
    createEnableColorTemperatureAttr().setValue(value, time);
  }
  bool DomeLightPrim::getEnableColorTemperature(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsEnableColorTemperature).getValue<bool>(v, time); return v;
  }

  Attribute DomeLightPrim::createExposureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsExposure, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getExposureAttr() const {
    return getAttr(LuxTokens.inputsExposure);
  }
  void DomeLightPrim::setExposure(float value, fdk::TimeValue time) {
    createExposureAttr().setValue(value, time);
  }
  float DomeLightPrim::getExposure(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsExposure).getValue<float>(v, time); return v;
  }

  Attribute DomeLightPrim::createIntensityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsIntensity, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getIntensityAttr() const {
    return getAttr(LuxTokens.inputsIntensity);
  }
  void DomeLightPrim::setIntensity(float value, fdk::TimeValue time) {
    createIntensityAttr().setValue(value, time);
  }
  float DomeLightPrim::getIntensity(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsIntensity).getValue<float>(v, time); return v;
  }

  Attribute DomeLightPrim::createNormalizeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsNormalize, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getNormalizeAttr() const {
    return getAttr(LuxTokens.inputsNormalize);
  }
  void DomeLightPrim::setNormalize(bool value, fdk::TimeValue time) {
    createNormalizeAttr().setValue(value, time);
  }
  bool DomeLightPrim::getNormalize(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsNormalize).getValue<bool>(v, time); return v;
  }

  Attribute DomeLightPrim::createSpecularAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsSpecular, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getSpecularAttr() const {
    return getAttr(LuxTokens.inputsSpecular);
  }
  void DomeLightPrim::setSpecular(float value, fdk::TimeValue time) {
    createSpecularAttr().setValue(value, time);
  }
  float DomeLightPrim::getSpecular(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsSpecular).getValue<float>(v, time); return v;
  }

  Attribute DomeLightPrim::createTextureFileAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsTextureFile, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getTextureFileAttr() const {
    return getAttr(LuxTokens.inputsTextureFile);
  }
  void DomeLightPrim::setTextureFile(const AssetPath& value, fdk::TimeValue time) {
    createTextureFileAttr().setValue(value, time);
  }
  AssetPath DomeLightPrim::getTextureFile(fdk::TimeValue time) const {
    AssetPath v; getAttr(LuxTokens.inputsTextureFile).getValue<AssetPath>(v, time); return v;
  }

  Attribute DomeLightPrim::createTextureFormatAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsTextureFormat, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getTextureFormatAttr() const {
    return getAttr(LuxTokens.inputsTextureFormat);
  }
  void DomeLightPrim::setTextureFormat(const Token& value, fdk::TimeValue time) {
    createTextureFormatAttr().setValue(value, time);
  }
  Token DomeLightPrim::getTextureFormat(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.inputsTextureFormat).getValue<Token>(v, time); return v;
  }

  Attribute DomeLightPrim::createShaderIdAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.lightShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute DomeLightPrim::getShaderIdAttr() const {
    return getAttr(LuxTokens.lightShaderId);
  }
  void DomeLightPrim::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token DomeLightPrim::getShaderId(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.lightShaderId).getValue<Token>(v, time); return v;
  }

  Relationship DomeLightPrim::createPortalsRel() {
    return createRelationship(LuxTokens.portals);
  }
  Relationship DomeLightPrim::getPortalsRel() const {
    return getRelationship(LuxTokens.portals);
  }
  void DomeLightPrim::setPortals(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.portals).setTargets(value);
  }
  PathArray DomeLightPrim::getPortals(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.portals).getTargets();
  }

  Relationship DomeLightPrim::createProxyPrimRel() {
    return createRelationship(LuxTokens.proxyPrim);
  }
  Relationship DomeLightPrim::getProxyPrimRel() const {
    return getRelationship(LuxTokens.proxyPrim);
  }
  void DomeLightPrim::setProxyPrim(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.proxyPrim).setTargets(value);
  }
  PathArray DomeLightPrim::getProxyPrim(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.proxyPrim).getTargets();
  }

  Attribute DomeLightPrim::createPurposeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.purpose, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute DomeLightPrim::getPurposeAttr() const {
    return getAttr(LuxTokens.purpose);
  }
  void DomeLightPrim::setPurpose(const Token& value, fdk::TimeValue time) {
    createPurposeAttr().setValue(value, time);
  }
  Token DomeLightPrim::getPurpose(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.purpose).getValue<Token>(v, time); return v;
  }

  Attribute DomeLightPrim::createVisibilityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.visibility, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute DomeLightPrim::getVisibilityAttr() const {
    return getAttr(LuxTokens.visibility);
  }
  void DomeLightPrim::setVisibility(const Token& value, fdk::TimeValue time) {
    createVisibilityAttr().setValue(value, time);
  }
  Token DomeLightPrim::getVisibility(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.visibility).getValue<Token>(v, time); return v;
  }

  Attribute DomeLightPrim::createXformOpOrderAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.xformOpOrder, Value::TokenArray, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute DomeLightPrim::getXformOpOrderAttr() const {
    return getAttr(LuxTokens.xformOpOrder);
  }
  void DomeLightPrim::setXformOpOrder(const TokenArray& value, fdk::TimeValue time) {
    createXformOpOrderAttr().setValue(value, time);
  }
  TokenArray DomeLightPrim::getXformOpOrder(fdk::TimeValue time) const {
    TokenArray v; getAttr(LuxTokens.xformOpOrder).getValue<TokenArray>(v, time); return v;
  }

  usg::CollectionAPI DomeLightPrim::getLightLink() const { return usg::CollectionAPI(*this, "lightLink"); }

  usg::CollectionAPI DomeLightPrim::getShadowLink() const { return usg::CollectionAPI(*this, "shadowLink"); }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
