// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/GeometryLightPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  GeometryLightPrim::GeometryLightPrim() : NonboundableLightBasePrim() {}
  GeometryLightPrim::GeometryLightPrim(const Prim& prim) : NonboundableLightBasePrim(prim) {
    validate();
  }
  GeometryLightPrim::~GeometryLightPrim() {}

  bool GeometryLightPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = GeometryLightPrim();
      return false;
    }
    return true;
  }

  bool GeometryLightPrim::isValidPrim(const Prim& prim) {
    return prim.isA(LuxTokens.types.GeometryLight);
  }
  
  GeometryLightPrim GeometryLightPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? GeometryLightPrim(layer->definePrim(path, LuxTokens.types.GeometryLight)) : GeometryLightPrim();
  }

  GeometryLightPrim GeometryLightPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? GeometryLightPrim(layer->overridePrim(prim)) : GeometryLightPrim();
  }

  GeometryLightPrim GeometryLightPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return GeometryLightPrim(stage->getPrimAtPath(path));
  }

  Relationship GeometryLightPrim::createFiltersRel() {
    return createRelationship(LuxTokens.filters);
  }
  Relationship GeometryLightPrim::getFiltersRel() const {
    return getRelationship(LuxTokens.filters);
  }
  void GeometryLightPrim::setFilters(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.filters).setTargets(value);
  }
  PathArray GeometryLightPrim::getFilters(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.filters).getTargets();
  }

  Relationship GeometryLightPrim::createGeometryRel() {
    return createRelationship(LuxTokens.geometry);
  }
  Relationship GeometryLightPrim::getGeometryRel() const {
    return getRelationship(LuxTokens.geometry);
  }
  void GeometryLightPrim::setGeometry(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.geometry).setTargets(value);
  }
  PathArray GeometryLightPrim::getGeometry(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.geometry).getTargets();
  }

  Attribute GeometryLightPrim::createColorAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColor, Value::Color3f, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getColorAttr() const {
    return getAttr(LuxTokens.inputsColor);
  }
  void GeometryLightPrim::setColor(const fdk::Vec3f& value, fdk::TimeValue time) {
    createColorAttr().setValue(value, time);
  }
  fdk::Vec3f GeometryLightPrim::getColor(fdk::TimeValue time) const {
    fdk::Vec3f v; getAttr(LuxTokens.inputsColor).getValue<fdk::Vec3f>(v, time); return v;
  }

  Attribute GeometryLightPrim::createColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColorTemperature, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsColorTemperature);
  }
  void GeometryLightPrim::setColorTemperature(float value, fdk::TimeValue time) {
    createColorTemperatureAttr().setValue(value, time);
  }
  float GeometryLightPrim::getColorTemperature(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsColorTemperature).getValue<float>(v, time); return v;
  }

  Attribute GeometryLightPrim::createDiffuseAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsDiffuse, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getDiffuseAttr() const {
    return getAttr(LuxTokens.inputsDiffuse);
  }
  void GeometryLightPrim::setDiffuse(float value, fdk::TimeValue time) {
    createDiffuseAttr().setValue(value, time);
  }
  float GeometryLightPrim::getDiffuse(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsDiffuse).getValue<float>(v, time); return v;
  }

  Attribute GeometryLightPrim::createEnableColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsEnableColorTemperature, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getEnableColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsEnableColorTemperature);
  }
  void GeometryLightPrim::setEnableColorTemperature(bool value, fdk::TimeValue time) {
    createEnableColorTemperatureAttr().setValue(value, time);
  }
  bool GeometryLightPrim::getEnableColorTemperature(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsEnableColorTemperature).getValue<bool>(v, time); return v;
  }

  Attribute GeometryLightPrim::createExposureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsExposure, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getExposureAttr() const {
    return getAttr(LuxTokens.inputsExposure);
  }
  void GeometryLightPrim::setExposure(float value, fdk::TimeValue time) {
    createExposureAttr().setValue(value, time);
  }
  float GeometryLightPrim::getExposure(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsExposure).getValue<float>(v, time); return v;
  }

  Attribute GeometryLightPrim::createIntensityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsIntensity, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getIntensityAttr() const {
    return getAttr(LuxTokens.inputsIntensity);
  }
  void GeometryLightPrim::setIntensity(float value, fdk::TimeValue time) {
    createIntensityAttr().setValue(value, time);
  }
  float GeometryLightPrim::getIntensity(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsIntensity).getValue<float>(v, time); return v;
  }

  Attribute GeometryLightPrim::createNormalizeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsNormalize, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getNormalizeAttr() const {
    return getAttr(LuxTokens.inputsNormalize);
  }
  void GeometryLightPrim::setNormalize(bool value, fdk::TimeValue time) {
    createNormalizeAttr().setValue(value, time);
  }
  bool GeometryLightPrim::getNormalize(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsNormalize).getValue<bool>(v, time); return v;
  }

  Attribute GeometryLightPrim::createSpecularAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsSpecular, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getSpecularAttr() const {
    return getAttr(LuxTokens.inputsSpecular);
  }
  void GeometryLightPrim::setSpecular(float value, fdk::TimeValue time) {
    createSpecularAttr().setValue(value, time);
  }
  float GeometryLightPrim::getSpecular(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsSpecular).getValue<float>(v, time); return v;
  }

  Attribute GeometryLightPrim::createShaderIdAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.lightShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GeometryLightPrim::getShaderIdAttr() const {
    return getAttr(LuxTokens.lightShaderId);
  }
  void GeometryLightPrim::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token GeometryLightPrim::getShaderId(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.lightShaderId).getValue<Token>(v, time); return v;
  }

  Relationship GeometryLightPrim::createProxyPrimRel() {
    return createRelationship(LuxTokens.proxyPrim);
  }
  Relationship GeometryLightPrim::getProxyPrimRel() const {
    return getRelationship(LuxTokens.proxyPrim);
  }
  void GeometryLightPrim::setProxyPrim(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.proxyPrim).setTargets(value);
  }
  PathArray GeometryLightPrim::getProxyPrim(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.proxyPrim).getTargets();
  }

  Attribute GeometryLightPrim::createPurposeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.purpose, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GeometryLightPrim::getPurposeAttr() const {
    return getAttr(LuxTokens.purpose);
  }
  void GeometryLightPrim::setPurpose(const Token& value, fdk::TimeValue time) {
    createPurposeAttr().setValue(value, time);
  }
  Token GeometryLightPrim::getPurpose(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.purpose).getValue<Token>(v, time); return v;
  }

  Attribute GeometryLightPrim::createVisibilityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.visibility, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute GeometryLightPrim::getVisibilityAttr() const {
    return getAttr(LuxTokens.visibility);
  }
  void GeometryLightPrim::setVisibility(const Token& value, fdk::TimeValue time) {
    createVisibilityAttr().setValue(value, time);
  }
  Token GeometryLightPrim::getVisibility(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.visibility).getValue<Token>(v, time); return v;
  }

  Attribute GeometryLightPrim::createXformOpOrderAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.xformOpOrder, Value::TokenArray, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute GeometryLightPrim::getXformOpOrderAttr() const {
    return getAttr(LuxTokens.xformOpOrder);
  }
  void GeometryLightPrim::setXformOpOrder(const TokenArray& value, fdk::TimeValue time) {
    createXformOpOrderAttr().setValue(value, time);
  }
  TokenArray GeometryLightPrim::getXformOpOrder(fdk::TimeValue time) const {
    TokenArray v; getAttr(LuxTokens.xformOpOrder).getValue<TokenArray>(v, time); return v;
  }

  usg::CollectionAPI GeometryLightPrim::getLightLink() const { return usg::CollectionAPI(*this, "lightLink"); }

  usg::CollectionAPI GeometryLightPrim::getShadowLink() const { return usg::CollectionAPI(*this, "shadowLink"); }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
