// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/LightAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  LightAPI::LightAPI() : _prim() {}
  LightAPI::LightAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  LightAPI::~LightAPI() {}

  bool LightAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = LightAPI();
      return false;
    }
    return true;
  }

  bool LightAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(LuxTokens.types.LightAPI);
  }
  
  void LightAPI::apply() {
    _prim.addAppliedSchema(LuxTokens.types.LightAPI);
  }

  Attribute LightAPI::createColorAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsColor, Value::Color3f, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightAPI::getColorAttr() const {
    return _prim.getAttr(LuxTokens.inputsColor);
  }
  void LightAPI::setColor(const fdk::Vec3f& value, fdk::TimeValue time) {
    createColorAttr().setValue(value, time);
  }
  fdk::Vec3f LightAPI::getColor(fdk::TimeValue time) const {
    fdk::Vec3f v; _prim.getAttr(LuxTokens.inputsColor).getValue<fdk::Vec3f>(v, time); return v;
  }

  Attribute LightAPI::createColorTemperatureAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsColorTemperature, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightAPI::getColorTemperatureAttr() const {
    return _prim.getAttr(LuxTokens.inputsColorTemperature);
  }
  void LightAPI::setColorTemperature(float value, fdk::TimeValue time) {
    createColorTemperatureAttr().setValue(value, time);
  }
  float LightAPI::getColorTemperature(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsColorTemperature).getValue<float>(v, time); return v;
  }

  Attribute LightAPI::createDiffuseAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsDiffuse, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightAPI::getDiffuseAttr() const {
    return _prim.getAttr(LuxTokens.inputsDiffuse);
  }
  void LightAPI::setDiffuse(float value, fdk::TimeValue time) {
    createDiffuseAttr().setValue(value, time);
  }
  float LightAPI::getDiffuse(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsDiffuse).getValue<float>(v, time); return v;
  }

  Attribute LightAPI::createEnableColorTemperatureAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsEnableColorTemperature, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightAPI::getEnableColorTemperatureAttr() const {
    return _prim.getAttr(LuxTokens.inputsEnableColorTemperature);
  }
  void LightAPI::setEnableColorTemperature(bool value, fdk::TimeValue time) {
    createEnableColorTemperatureAttr().setValue(value, time);
  }
  bool LightAPI::getEnableColorTemperature(fdk::TimeValue time) const {
    bool v; _prim.getAttr(LuxTokens.inputsEnableColorTemperature).getValue<bool>(v, time); return v;
  }

  Attribute LightAPI::createExposureAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsExposure, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightAPI::getExposureAttr() const {
    return _prim.getAttr(LuxTokens.inputsExposure);
  }
  void LightAPI::setExposure(float value, fdk::TimeValue time) {
    createExposureAttr().setValue(value, time);
  }
  float LightAPI::getExposure(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsExposure).getValue<float>(v, time); return v;
  }

  Attribute LightAPI::createIntensityAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsIntensity, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightAPI::getIntensityAttr() const {
    return _prim.getAttr(LuxTokens.inputsIntensity);
  }
  void LightAPI::setIntensity(float value, fdk::TimeValue time) {
    createIntensityAttr().setValue(value, time);
  }
  float LightAPI::getIntensity(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsIntensity).getValue<float>(v, time); return v;
  }

  Attribute LightAPI::createNormalizeAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsNormalize, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightAPI::getNormalizeAttr() const {
    return _prim.getAttr(LuxTokens.inputsNormalize);
  }
  void LightAPI::setNormalize(bool value, fdk::TimeValue time) {
    createNormalizeAttr().setValue(value, time);
  }
  bool LightAPI::getNormalize(fdk::TimeValue time) const {
    bool v; _prim.getAttr(LuxTokens.inputsNormalize).getValue<bool>(v, time); return v;
  }

  Attribute LightAPI::createSpecularAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsSpecular, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightAPI::getSpecularAttr() const {
    return _prim.getAttr(LuxTokens.inputsSpecular);
  }
  void LightAPI::setSpecular(float value, fdk::TimeValue time) {
    createSpecularAttr().setValue(value, time);
  }
  float LightAPI::getSpecular(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsSpecular).getValue<float>(v, time); return v;
  }

  Relationship LightAPI::createFiltersRel() {
    return _prim.createRelationship(LuxTokens.lightFilters);
  }
  Relationship LightAPI::getFiltersRel() const {
    return _prim.getRelationship(LuxTokens.lightFilters);
  }
  void LightAPI::setFilters(const PathArray& value, fdk::TimeValue time) {
    _prim.createRelationship(LuxTokens.lightFilters).setTargets(value);
  }
  PathArray LightAPI::getFilters(fdk::TimeValue time) const {
    return _prim.getRelationship(LuxTokens.lightFilters).getTargets();
  }

  Attribute LightAPI::createMaterialSyncModeAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.lightMaterialSyncMode, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute LightAPI::getMaterialSyncModeAttr() const {
    return _prim.getAttr(LuxTokens.lightMaterialSyncMode);
  }
  void LightAPI::setMaterialSyncMode(const Token& value, fdk::TimeValue time) {
    createMaterialSyncModeAttr().setValue(value, time);
  }
  Token LightAPI::getMaterialSyncMode(fdk::TimeValue time) const {
    Token v; _prim.getAttr(LuxTokens.lightMaterialSyncMode).getValue<Token>(v, time); return v;
  }

  Attribute LightAPI::createShaderIdAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.lightShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute LightAPI::getShaderIdAttr() const {
    return _prim.getAttr(LuxTokens.lightShaderId);
  }
  void LightAPI::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token LightAPI::getShaderId(fdk::TimeValue time) const {
    Token v; _prim.getAttr(LuxTokens.lightShaderId).getValue<Token>(v, time); return v;
  }

  usg::CollectionAPI LightAPI::getLightLink() const { return usg::CollectionAPI(_prim, "lightLink"); }

  usg::CollectionAPI LightAPI::getShadowLink() const { return usg::CollectionAPI(_prim, "shadowLink"); }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
