// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/LightFilterPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  LightFilterPrim::LightFilterPrim() : Prim() {}
  LightFilterPrim::LightFilterPrim(const Prim& prim) : Prim(prim) {
    validate();
  }
  LightFilterPrim::~LightFilterPrim() {}

  bool LightFilterPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = LightFilterPrim();
      return false;
    }
    return true;
  }

  bool LightFilterPrim::isValidPrim(const Prim& prim) {
    return prim.isA(LuxTokens.types.LightFilter);
  }
  

  LightFilterPrim LightFilterPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? LightFilterPrim(layer->overridePrim(prim)) : LightFilterPrim();
  }

  LightFilterPrim LightFilterPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return LightFilterPrim(stage->getPrimAtPath(path));
  }

  Attribute LightFilterPrim::createShaderIdAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.lightFilterShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute LightFilterPrim::getShaderIdAttr() const {
    return getAttr(LuxTokens.lightFilterShaderId);
  }
  void LightFilterPrim::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token LightFilterPrim::getShaderId(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.lightFilterShaderId).getValue<Token>(v, time); return v;
  }

  Relationship LightFilterPrim::createProxyPrimRel() {
    return createRelationship(LuxTokens.proxyPrim);
  }
  Relationship LightFilterPrim::getProxyPrimRel() const {
    return getRelationship(LuxTokens.proxyPrim);
  }
  void LightFilterPrim::setProxyPrim(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.proxyPrim).setTargets(value);
  }
  PathArray LightFilterPrim::getProxyPrim(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.proxyPrim).getTargets();
  }

  Attribute LightFilterPrim::createPurposeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.purpose, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute LightFilterPrim::getPurposeAttr() const {
    return getAttr(LuxTokens.purpose);
  }
  void LightFilterPrim::setPurpose(const Token& value, fdk::TimeValue time) {
    createPurposeAttr().setValue(value, time);
  }
  Token LightFilterPrim::getPurpose(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.purpose).getValue<Token>(v, time); return v;
  }

  Attribute LightFilterPrim::createVisibilityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.visibility, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightFilterPrim::getVisibilityAttr() const {
    return getAttr(LuxTokens.visibility);
  }
  void LightFilterPrim::setVisibility(const Token& value, fdk::TimeValue time) {
    createVisibilityAttr().setValue(value, time);
  }
  Token LightFilterPrim::getVisibility(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.visibility).getValue<Token>(v, time); return v;
  }

  Attribute LightFilterPrim::createXformOpOrderAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.xformOpOrder, Value::TokenArray, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute LightFilterPrim::getXformOpOrderAttr() const {
    return getAttr(LuxTokens.xformOpOrder);
  }
  void LightFilterPrim::setXformOpOrder(const TokenArray& value, fdk::TimeValue time) {
    createXformOpOrderAttr().setValue(value, time);
  }
  TokenArray LightFilterPrim::getXformOpOrder(fdk::TimeValue time) const {
    TokenArray v; getAttr(LuxTokens.xformOpOrder).getValue<TokenArray>(v, time); return v;
  }

  usg::CollectionAPI LightFilterPrim::getFilterLink() const { return usg::CollectionAPI(*this, "filterLink"); }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
