// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/LightListAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  LightListAPI::LightListAPI() : _prim() {}
  LightListAPI::LightListAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  LightListAPI::~LightListAPI() {}

  bool LightListAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = LightListAPI();
      return false;
    }
    return true;
  }

  bool LightListAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(LuxTokens.types.LightListAPI);
  }
  
  void LightListAPI::apply() {
    _prim.addAppliedSchema(LuxTokens.types.LightListAPI);
  }

  Relationship LightListAPI::createLightListRel() {
    return _prim.createRelationship(LuxTokens.lightList);
  }
  Relationship LightListAPI::getLightListRel() const {
    return _prim.getRelationship(LuxTokens.lightList);
  }
  void LightListAPI::setLightList(const PathArray& value, fdk::TimeValue time) {
    _prim.createRelationship(LuxTokens.lightList).setTargets(value);
  }
  PathArray LightListAPI::getLightList(fdk::TimeValue time) const {
    return _prim.getRelationship(LuxTokens.lightList).getTargets();
  }

  Attribute LightListAPI::createCacheBehaviorAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.lightListCacheBehavior, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute LightListAPI::getCacheBehaviorAttr() const {
    return _prim.getAttr(LuxTokens.lightListCacheBehavior);
  }
  void LightListAPI::setCacheBehavior(const Token& value, fdk::TimeValue time) {
    createCacheBehaviorAttr().setValue(value, time);
  }
  Token LightListAPI::getCacheBehavior(fdk::TimeValue time) const {
    Token v; _prim.getAttr(LuxTokens.lightListCacheBehavior).getValue<Token>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
