// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/ListAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  ListAPI::ListAPI() : _prim() {}
  ListAPI::ListAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  ListAPI::~ListAPI() {}

  bool ListAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = ListAPI();
      return false;
    }
    return true;
  }

  bool ListAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(LuxTokens.types.ListAPI);
  }
  
  void ListAPI::apply() {
    _prim.addAppliedSchema(LuxTokens.types.ListAPI);
  }

  Relationship ListAPI::createLightListRel() {
    return _prim.createRelationship(LuxTokens.lightList);
  }
  Relationship ListAPI::getLightListRel() const {
    return _prim.getRelationship(LuxTokens.lightList);
  }
  void ListAPI::setLightList(const PathArray& value, fdk::TimeValue time) {
    _prim.createRelationship(LuxTokens.lightList).setTargets(value);
  }
  PathArray ListAPI::getLightList(fdk::TimeValue time) const {
    return _prim.getRelationship(LuxTokens.lightList).getTargets();
  }

  Attribute ListAPI::createCacheBehaviorAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.lightListCacheBehavior, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ListAPI::getCacheBehaviorAttr() const {
    return _prim.getAttr(LuxTokens.lightListCacheBehavior);
  }
  void ListAPI::setCacheBehavior(const Token& value, fdk::TimeValue time) {
    createCacheBehaviorAttr().setValue(value, time);
  }
  Token ListAPI::getCacheBehavior(fdk::TimeValue time) const {
    Token v; _prim.getAttr(LuxTokens.lightListCacheBehavior).getValue<Token>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
