// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/MeshLightAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  MeshLightAPI::MeshLightAPI() : _prim() {}
  MeshLightAPI::MeshLightAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  MeshLightAPI::~MeshLightAPI() {}

  bool MeshLightAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = MeshLightAPI();
      return false;
    }
    return true;
  }

  bool MeshLightAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(LuxTokens.types.MeshLightAPI);
  }
  
  void MeshLightAPI::apply() {
    _prim.addAppliedSchema(LuxTokens.types.MeshLightAPI);
  }

  Attribute MeshLightAPI::createMaterialSyncModeAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.lightMaterialSyncMode, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute MeshLightAPI::getMaterialSyncModeAttr() const {
    return _prim.getAttr(LuxTokens.lightMaterialSyncMode);
  }
  void MeshLightAPI::setMaterialSyncMode(const Token& value, fdk::TimeValue time) {
    createMaterialSyncModeAttr().setValue(value, time);
  }
  Token MeshLightAPI::getMaterialSyncMode(fdk::TimeValue time) const {
    Token v; _prim.getAttr(LuxTokens.lightMaterialSyncMode).getValue<Token>(v, time); return v;
  }

  Attribute MeshLightAPI::createShaderIdAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.lightShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute MeshLightAPI::getShaderIdAttr() const {
    return _prim.getAttr(LuxTokens.lightShaderId);
  }
  void MeshLightAPI::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token MeshLightAPI::getShaderId(fdk::TimeValue time) const {
    Token v; _prim.getAttr(LuxTokens.lightShaderId).getValue<Token>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
