// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/RectLightPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  RectLightPrim::RectLightPrim() : BoundableLightBasePrim() {}
  RectLightPrim::RectLightPrim(const Prim& prim) : BoundableLightBasePrim(prim) {
    validate();
  }
  RectLightPrim::~RectLightPrim() {}

  bool RectLightPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = RectLightPrim();
      return false;
    }
    return true;
  }

  bool RectLightPrim::isValidPrim(const Prim& prim) {
    return prim.isA(LuxTokens.types.RectLight);
  }
  
  RectLightPrim RectLightPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? RectLightPrim(layer->definePrim(path, LuxTokens.types.RectLight)) : RectLightPrim();
  }

  RectLightPrim RectLightPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? RectLightPrim(layer->overridePrim(prim)) : RectLightPrim();
  }

  RectLightPrim RectLightPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return RectLightPrim(stage->getPrimAtPath(path));
  }

  Relationship RectLightPrim::createFiltersRel() {
    return createRelationship(LuxTokens.filters);
  }
  Relationship RectLightPrim::getFiltersRel() const {
    return getRelationship(LuxTokens.filters);
  }
  void RectLightPrim::setFilters(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.filters).setTargets(value);
  }
  PathArray RectLightPrim::getFilters(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.filters).getTargets();
  }

  Attribute RectLightPrim::createColorAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColor, Value::Color3f, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getColorAttr() const {
    return getAttr(LuxTokens.inputsColor);
  }
  void RectLightPrim::setColor(const fdk::Vec3f& value, fdk::TimeValue time) {
    createColorAttr().setValue(value, time);
  }
  fdk::Vec3f RectLightPrim::getColor(fdk::TimeValue time) const {
    fdk::Vec3f v; getAttr(LuxTokens.inputsColor).getValue<fdk::Vec3f>(v, time); return v;
  }

  Attribute RectLightPrim::createColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColorTemperature, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsColorTemperature);
  }
  void RectLightPrim::setColorTemperature(float value, fdk::TimeValue time) {
    createColorTemperatureAttr().setValue(value, time);
  }
  float RectLightPrim::getColorTemperature(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsColorTemperature).getValue<float>(v, time); return v;
  }

  Attribute RectLightPrim::createDiffuseAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsDiffuse, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getDiffuseAttr() const {
    return getAttr(LuxTokens.inputsDiffuse);
  }
  void RectLightPrim::setDiffuse(float value, fdk::TimeValue time) {
    createDiffuseAttr().setValue(value, time);
  }
  float RectLightPrim::getDiffuse(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsDiffuse).getValue<float>(v, time); return v;
  }

  Attribute RectLightPrim::createEnableColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsEnableColorTemperature, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getEnableColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsEnableColorTemperature);
  }
  void RectLightPrim::setEnableColorTemperature(bool value, fdk::TimeValue time) {
    createEnableColorTemperatureAttr().setValue(value, time);
  }
  bool RectLightPrim::getEnableColorTemperature(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsEnableColorTemperature).getValue<bool>(v, time); return v;
  }

  Attribute RectLightPrim::createExposureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsExposure, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getExposureAttr() const {
    return getAttr(LuxTokens.inputsExposure);
  }
  void RectLightPrim::setExposure(float value, fdk::TimeValue time) {
    createExposureAttr().setValue(value, time);
  }
  float RectLightPrim::getExposure(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsExposure).getValue<float>(v, time); return v;
  }

  Attribute RectLightPrim::createHeightAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsHeight, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getHeightAttr() const {
    return getAttr(LuxTokens.inputsHeight);
  }
  void RectLightPrim::setHeight(float value, fdk::TimeValue time) {
    createHeightAttr().setValue(value, time);
  }
  float RectLightPrim::getHeight(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsHeight).getValue<float>(v, time); return v;
  }

  Attribute RectLightPrim::createIntensityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsIntensity, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getIntensityAttr() const {
    return getAttr(LuxTokens.inputsIntensity);
  }
  void RectLightPrim::setIntensity(float value, fdk::TimeValue time) {
    createIntensityAttr().setValue(value, time);
  }
  float RectLightPrim::getIntensity(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsIntensity).getValue<float>(v, time); return v;
  }

  Attribute RectLightPrim::createNormalizeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsNormalize, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getNormalizeAttr() const {
    return getAttr(LuxTokens.inputsNormalize);
  }
  void RectLightPrim::setNormalize(bool value, fdk::TimeValue time) {
    createNormalizeAttr().setValue(value, time);
  }
  bool RectLightPrim::getNormalize(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsNormalize).getValue<bool>(v, time); return v;
  }

  Attribute RectLightPrim::createSpecularAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsSpecular, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getSpecularAttr() const {
    return getAttr(LuxTokens.inputsSpecular);
  }
  void RectLightPrim::setSpecular(float value, fdk::TimeValue time) {
    createSpecularAttr().setValue(value, time);
  }
  float RectLightPrim::getSpecular(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsSpecular).getValue<float>(v, time); return v;
  }

  Attribute RectLightPrim::createTextureFileAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsTextureFile, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getTextureFileAttr() const {
    return getAttr(LuxTokens.inputsTextureFile);
  }
  void RectLightPrim::setTextureFile(const AssetPath& value, fdk::TimeValue time) {
    createTextureFileAttr().setValue(value, time);
  }
  AssetPath RectLightPrim::getTextureFile(fdk::TimeValue time) const {
    AssetPath v; getAttr(LuxTokens.inputsTextureFile).getValue<AssetPath>(v, time); return v;
  }

  Attribute RectLightPrim::createWidthAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsWidth, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getWidthAttr() const {
    return getAttr(LuxTokens.inputsWidth);
  }
  void RectLightPrim::setWidth(float value, fdk::TimeValue time) {
    createWidthAttr().setValue(value, time);
  }
  float RectLightPrim::getWidth(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsWidth).getValue<float>(v, time); return v;
  }

  Attribute RectLightPrim::createShaderIdAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.lightShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute RectLightPrim::getShaderIdAttr() const {
    return getAttr(LuxTokens.lightShaderId);
  }
  void RectLightPrim::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token RectLightPrim::getShaderId(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.lightShaderId).getValue<Token>(v, time); return v;
  }

  Relationship RectLightPrim::createProxyPrimRel() {
    return createRelationship(LuxTokens.proxyPrim);
  }
  Relationship RectLightPrim::getProxyPrimRel() const {
    return getRelationship(LuxTokens.proxyPrim);
  }
  void RectLightPrim::setProxyPrim(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.proxyPrim).setTargets(value);
  }
  PathArray RectLightPrim::getProxyPrim(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.proxyPrim).getTargets();
  }

  Attribute RectLightPrim::createPurposeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.purpose, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute RectLightPrim::getPurposeAttr() const {
    return getAttr(LuxTokens.purpose);
  }
  void RectLightPrim::setPurpose(const Token& value, fdk::TimeValue time) {
    createPurposeAttr().setValue(value, time);
  }
  Token RectLightPrim::getPurpose(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.purpose).getValue<Token>(v, time); return v;
  }

  Attribute RectLightPrim::createVisibilityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.visibility, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute RectLightPrim::getVisibilityAttr() const {
    return getAttr(LuxTokens.visibility);
  }
  void RectLightPrim::setVisibility(const Token& value, fdk::TimeValue time) {
    createVisibilityAttr().setValue(value, time);
  }
  Token RectLightPrim::getVisibility(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.visibility).getValue<Token>(v, time); return v;
  }

  Attribute RectLightPrim::createXformOpOrderAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.xformOpOrder, Value::TokenArray, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute RectLightPrim::getXformOpOrderAttr() const {
    return getAttr(LuxTokens.xformOpOrder);
  }
  void RectLightPrim::setXformOpOrder(const TokenArray& value, fdk::TimeValue time) {
    createXformOpOrderAttr().setValue(value, time);
  }
  TokenArray RectLightPrim::getXformOpOrder(fdk::TimeValue time) const {
    TokenArray v; getAttr(LuxTokens.xformOpOrder).getValue<TokenArray>(v, time); return v;
  }

  usg::CollectionAPI RectLightPrim::getLightLink() const { return usg::CollectionAPI(*this, "lightLink"); }

  usg::CollectionAPI RectLightPrim::getShadowLink() const { return usg::CollectionAPI(*this, "shadowLink"); }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
