// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/ShadowAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  ShadowAPI::ShadowAPI() : _prim() {}
  ShadowAPI::ShadowAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  ShadowAPI::~ShadowAPI() {}

  bool ShadowAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = ShadowAPI();
      return false;
    }
    return true;
  }

  bool ShadowAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(LuxTokens.types.ShadowAPI);
  }
  
  void ShadowAPI::apply() {
    _prim.addAppliedSchema(LuxTokens.types.ShadowAPI);
  }

  Attribute ShadowAPI::createShadowColorAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShadowColor, Value::Color3f, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShadowAPI::getShadowColorAttr() const {
    return _prim.getAttr(LuxTokens.inputsShadowColor);
  }
  void ShadowAPI::setShadowColor(const fdk::Vec3f& value, fdk::TimeValue time) {
    createShadowColorAttr().setValue(value, time);
  }
  fdk::Vec3f ShadowAPI::getShadowColor(fdk::TimeValue time) const {
    fdk::Vec3f v; _prim.getAttr(LuxTokens.inputsShadowColor).getValue<fdk::Vec3f>(v, time); return v;
  }

  Attribute ShadowAPI::createShadowDistanceAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShadowDistance, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShadowAPI::getShadowDistanceAttr() const {
    return _prim.getAttr(LuxTokens.inputsShadowDistance);
  }
  void ShadowAPI::setShadowDistance(float value, fdk::TimeValue time) {
    createShadowDistanceAttr().setValue(value, time);
  }
  float ShadowAPI::getShadowDistance(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsShadowDistance).getValue<float>(v, time); return v;
  }

  Attribute ShadowAPI::createShadowEnableAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShadowEnable, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShadowAPI::getShadowEnableAttr() const {
    return _prim.getAttr(LuxTokens.inputsShadowEnable);
  }
  void ShadowAPI::setShadowEnable(bool value, fdk::TimeValue time) {
    createShadowEnableAttr().setValue(value, time);
  }
  bool ShadowAPI::getShadowEnable(fdk::TimeValue time) const {
    bool v; _prim.getAttr(LuxTokens.inputsShadowEnable).getValue<bool>(v, time); return v;
  }

  Attribute ShadowAPI::createShadowFalloffAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShadowFalloff, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShadowAPI::getShadowFalloffAttr() const {
    return _prim.getAttr(LuxTokens.inputsShadowFalloff);
  }
  void ShadowAPI::setShadowFalloff(float value, fdk::TimeValue time) {
    createShadowFalloffAttr().setValue(value, time);
  }
  float ShadowAPI::getShadowFalloff(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsShadowFalloff).getValue<float>(v, time); return v;
  }

  Attribute ShadowAPI::createShadowFalloffGammaAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShadowFalloffGamma, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShadowAPI::getShadowFalloffGammaAttr() const {
    return _prim.getAttr(LuxTokens.inputsShadowFalloffGamma);
  }
  void ShadowAPI::setShadowFalloffGamma(float value, fdk::TimeValue time) {
    createShadowFalloffGammaAttr().setValue(value, time);
  }
  float ShadowAPI::getShadowFalloffGamma(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsShadowFalloffGamma).getValue<float>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
