// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/ShapingAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  ShapingAPI::ShapingAPI() : _prim() {}
  ShapingAPI::ShapingAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  ShapingAPI::~ShapingAPI() {}

  bool ShapingAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = ShapingAPI();
      return false;
    }
    return true;
  }

  bool ShapingAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(LuxTokens.types.ShapingAPI);
  }
  
  void ShapingAPI::apply() {
    _prim.addAppliedSchema(LuxTokens.types.ShapingAPI);
  }

  Attribute ShapingAPI::createShapingConeAngleAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShapingConeAngle, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShapingAPI::getShapingConeAngleAttr() const {
    return _prim.getAttr(LuxTokens.inputsShapingConeAngle);
  }
  void ShapingAPI::setShapingConeAngle(float value, fdk::TimeValue time) {
    createShapingConeAngleAttr().setValue(value, time);
  }
  float ShapingAPI::getShapingConeAngle(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsShapingConeAngle).getValue<float>(v, time); return v;
  }

  Attribute ShapingAPI::createShapingConeSoftnessAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShapingConeSoftness, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShapingAPI::getShapingConeSoftnessAttr() const {
    return _prim.getAttr(LuxTokens.inputsShapingConeSoftness);
  }
  void ShapingAPI::setShapingConeSoftness(float value, fdk::TimeValue time) {
    createShapingConeSoftnessAttr().setValue(value, time);
  }
  float ShapingAPI::getShapingConeSoftness(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsShapingConeSoftness).getValue<float>(v, time); return v;
  }

  Attribute ShapingAPI::createShapingFocusAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShapingFocus, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShapingAPI::getShapingFocusAttr() const {
    return _prim.getAttr(LuxTokens.inputsShapingFocus);
  }
  void ShapingAPI::setShapingFocus(float value, fdk::TimeValue time) {
    createShapingFocusAttr().setValue(value, time);
  }
  float ShapingAPI::getShapingFocus(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsShapingFocus).getValue<float>(v, time); return v;
  }

  Attribute ShapingAPI::createShapingFocusTintAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShapingFocusTint, Value::Color3f, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShapingAPI::getShapingFocusTintAttr() const {
    return _prim.getAttr(LuxTokens.inputsShapingFocusTint);
  }
  void ShapingAPI::setShapingFocusTint(const fdk::Vec3f& value, fdk::TimeValue time) {
    createShapingFocusTintAttr().setValue(value, time);
  }
  fdk::Vec3f ShapingAPI::getShapingFocusTint(fdk::TimeValue time) const {
    fdk::Vec3f v; _prim.getAttr(LuxTokens.inputsShapingFocusTint).getValue<fdk::Vec3f>(v, time); return v;
  }

  Attribute ShapingAPI::createShapingIesAngleScaleAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShapingIesAngleScale, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShapingAPI::getShapingIesAngleScaleAttr() const {
    return _prim.getAttr(LuxTokens.inputsShapingIesAngleScale);
  }
  void ShapingAPI::setShapingIesAngleScale(float value, fdk::TimeValue time) {
    createShapingIesAngleScaleAttr().setValue(value, time);
  }
  float ShapingAPI::getShapingIesAngleScale(fdk::TimeValue time) const {
    float v; _prim.getAttr(LuxTokens.inputsShapingIesAngleScale).getValue<float>(v, time); return v;
  }

  Attribute ShapingAPI::createShapingIesFileAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShapingIesFile, Value::AssetPath, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShapingAPI::getShapingIesFileAttr() const {
    return _prim.getAttr(LuxTokens.inputsShapingIesFile);
  }
  void ShapingAPI::setShapingIesFile(const AssetPath& value, fdk::TimeValue time) {
    createShapingIesFileAttr().setValue(value, time);
  }
  AssetPath ShapingAPI::getShapingIesFile(fdk::TimeValue time) const {
    AssetPath v; _prim.getAttr(LuxTokens.inputsShapingIesFile).getValue<AssetPath>(v, time); return v;
  }

  Attribute ShapingAPI::createShapingIesNormalizeAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.inputsShapingIesNormalize, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute ShapingAPI::getShapingIesNormalizeAttr() const {
    return _prim.getAttr(LuxTokens.inputsShapingIesNormalize);
  }
  void ShapingAPI::setShapingIesNormalize(bool value, fdk::TimeValue time) {
    createShapingIesNormalizeAttr().setValue(value, time);
  }
  bool ShapingAPI::getShapingIesNormalize(fdk::TimeValue time) const {
    bool v; _prim.getAttr(LuxTokens.inputsShapingIesNormalize).getValue<bool>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
