// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/SphereLightPrim.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  SphereLightPrim::SphereLightPrim() : BoundableLightBasePrim() {}
  SphereLightPrim::SphereLightPrim(const Prim& prim) : BoundableLightBasePrim(prim) {
    validate();
  }
  SphereLightPrim::~SphereLightPrim() {}

  bool SphereLightPrim::validate() {
    if (!isValidPrim(*this)) {
      *this = SphereLightPrim();
      return false;
    }
    return true;
  }

  bool SphereLightPrim::isValidPrim(const Prim& prim) {
    return prim.isA(LuxTokens.types.SphereLight);
  }
  
  SphereLightPrim SphereLightPrim::defineInLayer(const LayerRef& layer, const Path& path)
  {
    return layer ? SphereLightPrim(layer->definePrim(path, LuxTokens.types.SphereLight)) : SphereLightPrim();
  }

  SphereLightPrim SphereLightPrim::overrideInLayer(const LayerRef& layer, const Prim& prim)
  {
    return layer ? SphereLightPrim(layer->overridePrim(prim)) : SphereLightPrim();
  }

  SphereLightPrim SphereLightPrim::getInStage(const StageRef& stage, const Path&  path)
  {
    return SphereLightPrim(stage->getPrimAtPath(path));
  }

  Relationship SphereLightPrim::createFiltersRel() {
    return createRelationship(LuxTokens.filters);
  }
  Relationship SphereLightPrim::getFiltersRel() const {
    return getRelationship(LuxTokens.filters);
  }
  void SphereLightPrim::setFilters(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.filters).setTargets(value);
  }
  PathArray SphereLightPrim::getFilters(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.filters).getTargets();
  }

  Attribute SphereLightPrim::createColorAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColor, Value::Color3f, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getColorAttr() const {
    return getAttr(LuxTokens.inputsColor);
  }
  void SphereLightPrim::setColor(const fdk::Vec3f& value, fdk::TimeValue time) {
    createColorAttr().setValue(value, time);
  }
  fdk::Vec3f SphereLightPrim::getColor(fdk::TimeValue time) const {
    fdk::Vec3f v; getAttr(LuxTokens.inputsColor).getValue<fdk::Vec3f>(v, time); return v;
  }

  Attribute SphereLightPrim::createColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsColorTemperature, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsColorTemperature);
  }
  void SphereLightPrim::setColorTemperature(float value, fdk::TimeValue time) {
    createColorTemperatureAttr().setValue(value, time);
  }
  float SphereLightPrim::getColorTemperature(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsColorTemperature).getValue<float>(v, time); return v;
  }

  Attribute SphereLightPrim::createDiffuseAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsDiffuse, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getDiffuseAttr() const {
    return getAttr(LuxTokens.inputsDiffuse);
  }
  void SphereLightPrim::setDiffuse(float value, fdk::TimeValue time) {
    createDiffuseAttr().setValue(value, time);
  }
  float SphereLightPrim::getDiffuse(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsDiffuse).getValue<float>(v, time); return v;
  }

  Attribute SphereLightPrim::createEnableColorTemperatureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsEnableColorTemperature, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getEnableColorTemperatureAttr() const {
    return getAttr(LuxTokens.inputsEnableColorTemperature);
  }
  void SphereLightPrim::setEnableColorTemperature(bool value, fdk::TimeValue time) {
    createEnableColorTemperatureAttr().setValue(value, time);
  }
  bool SphereLightPrim::getEnableColorTemperature(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsEnableColorTemperature).getValue<bool>(v, time); return v;
  }

  Attribute SphereLightPrim::createExposureAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsExposure, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getExposureAttr() const {
    return getAttr(LuxTokens.inputsExposure);
  }
  void SphereLightPrim::setExposure(float value, fdk::TimeValue time) {
    createExposureAttr().setValue(value, time);
  }
  float SphereLightPrim::getExposure(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsExposure).getValue<float>(v, time); return v;
  }

  Attribute SphereLightPrim::createIntensityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsIntensity, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getIntensityAttr() const {
    return getAttr(LuxTokens.inputsIntensity);
  }
  void SphereLightPrim::setIntensity(float value, fdk::TimeValue time) {
    createIntensityAttr().setValue(value, time);
  }
  float SphereLightPrim::getIntensity(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsIntensity).getValue<float>(v, time); return v;
  }

  Attribute SphereLightPrim::createNormalizeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsNormalize, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getNormalizeAttr() const {
    return getAttr(LuxTokens.inputsNormalize);
  }
  void SphereLightPrim::setNormalize(bool value, fdk::TimeValue time) {
    createNormalizeAttr().setValue(value, time);
  }
  bool SphereLightPrim::getNormalize(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.inputsNormalize).getValue<bool>(v, time); return v;
  }

  Attribute SphereLightPrim::createRadiusAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsRadius, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getRadiusAttr() const {
    return getAttr(LuxTokens.inputsRadius);
  }
  void SphereLightPrim::setRadius(float value, fdk::TimeValue time) {
    createRadiusAttr().setValue(value, time);
  }
  float SphereLightPrim::getRadius(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsRadius).getValue<float>(v, time); return v;
  }

  Attribute SphereLightPrim::createSpecularAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.inputsSpecular, Value::Float, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getSpecularAttr() const {
    return getAttr(LuxTokens.inputsSpecular);
  }
  void SphereLightPrim::setSpecular(float value, fdk::TimeValue time) {
    createSpecularAttr().setValue(value, time);
  }
  float SphereLightPrim::getSpecular(fdk::TimeValue time) const {
    float v; getAttr(LuxTokens.inputsSpecular).getValue<float>(v, time); return v;
  }

  Attribute SphereLightPrim::createShaderIdAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.lightShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute SphereLightPrim::getShaderIdAttr() const {
    return getAttr(LuxTokens.lightShaderId);
  }
  void SphereLightPrim::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token SphereLightPrim::getShaderId(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.lightShaderId).getValue<Token>(v, time); return v;
  }

  Relationship SphereLightPrim::createProxyPrimRel() {
    return createRelationship(LuxTokens.proxyPrim);
  }
  Relationship SphereLightPrim::getProxyPrimRel() const {
    return getRelationship(LuxTokens.proxyPrim);
  }
  void SphereLightPrim::setProxyPrim(const PathArray& value, fdk::TimeValue time) {
    createRelationship(LuxTokens.proxyPrim).setTargets(value);
  }
  PathArray SphereLightPrim::getProxyPrim(fdk::TimeValue time) const {
    return getRelationship(LuxTokens.proxyPrim).getTargets();
  }

  Attribute SphereLightPrim::createPurposeAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.purpose, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute SphereLightPrim::getPurposeAttr() const {
    return getAttr(LuxTokens.purpose);
  }
  void SphereLightPrim::setPurpose(const Token& value, fdk::TimeValue time) {
    createPurposeAttr().setValue(value, time);
  }
  Token SphereLightPrim::getPurpose(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.purpose).getValue<Token>(v, time); return v;
  }

  Attribute SphereLightPrim::createTreatAsPointAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.treatAsPoint, Value::Bool, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getTreatAsPointAttr() const {
    return getAttr(LuxTokens.treatAsPoint);
  }
  void SphereLightPrim::setTreatAsPoint(bool value, fdk::TimeValue time) {
    createTreatAsPointAttr().setValue(value, time);
  }
  bool SphereLightPrim::getTreatAsPoint(fdk::TimeValue time) const {
    bool v; getAttr(LuxTokens.treatAsPoint).getValue<bool>(v, time); return v;
  }

  Attribute SphereLightPrim::createVisibilityAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.visibility, Value::Token, false, TimeVariability::Varying, defaultValue);
  }
  Attribute SphereLightPrim::getVisibilityAttr() const {
    return getAttr(LuxTokens.visibility);
  }
  void SphereLightPrim::setVisibility(const Token& value, fdk::TimeValue time) {
    createVisibilityAttr().setValue(value, time);
  }
  Token SphereLightPrim::getVisibility(fdk::TimeValue time) const {
    Token v; getAttr(LuxTokens.visibility).getValue<Token>(v, time); return v;
  }

  Attribute SphereLightPrim::createXformOpOrderAttr(const Value& defaultValue) {
    return createAttr(LuxTokens.xformOpOrder, Value::TokenArray, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute SphereLightPrim::getXformOpOrderAttr() const {
    return getAttr(LuxTokens.xformOpOrder);
  }
  void SphereLightPrim::setXformOpOrder(const TokenArray& value, fdk::TimeValue time) {
    createXformOpOrderAttr().setValue(value, time);
  }
  TokenArray SphereLightPrim::getXformOpOrder(fdk::TimeValue time) const {
    TokenArray v; getAttr(LuxTokens.xformOpOrder).getValue<TokenArray>(v, time); return v;
  }

  usg::CollectionAPI SphereLightPrim::getLightLink() const { return usg::CollectionAPI(*this, "lightLink"); }

  usg::CollectionAPI SphereLightPrim::getShadowLink() const { return usg::CollectionAPI(*this, "shadowLink"); }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
