// Copyright (c) 2022 The Foundry Visionmongers Ltd. All Rights Reserved.

// This is automatically-generated code.
// You may add custom code between the --(BEGIN CUSTOM CODE)-- and --(END CUSTOM CODE)-- markers.
// Code added anywhere else will be destroyed when the code is generated.

#include "usg/lux/VolumeLightAPI.h"
#include "usg/geom/Layer.h"
#include "usg/geom/Stage.h"

namespace usg {
namespace lux {

  VolumeLightAPI::VolumeLightAPI() : _prim() {}
  VolumeLightAPI::VolumeLightAPI(const Prim& prim) : _prim(prim) {
    validate();
  }
  VolumeLightAPI::~VolumeLightAPI() {}

  bool VolumeLightAPI::validate() {
    if (!isValidPrim(_prim)) {
      *this = VolumeLightAPI();
      return false;
    }
    return true;
  }

  bool VolumeLightAPI::isValidPrim(const Prim& prim) {
    return prim.hasApi(LuxTokens.types.VolumeLightAPI);
  }
  
  void VolumeLightAPI::apply() {
    _prim.addAppliedSchema(LuxTokens.types.VolumeLightAPI);
  }

  Attribute VolumeLightAPI::createMaterialSyncModeAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.lightMaterialSyncMode, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute VolumeLightAPI::getMaterialSyncModeAttr() const {
    return _prim.getAttr(LuxTokens.lightMaterialSyncMode);
  }
  void VolumeLightAPI::setMaterialSyncMode(const Token& value, fdk::TimeValue time) {
    createMaterialSyncModeAttr().setValue(value, time);
  }
  Token VolumeLightAPI::getMaterialSyncMode(fdk::TimeValue time) const {
    Token v; _prim.getAttr(LuxTokens.lightMaterialSyncMode).getValue<Token>(v, time); return v;
  }

  Attribute VolumeLightAPI::createShaderIdAttr(const Value& defaultValue) {
    return _prim.createAttr(LuxTokens.lightShaderId, Value::Token, false, TimeVariability::Uniform, defaultValue);
  }
  Attribute VolumeLightAPI::getShaderIdAttr() const {
    return _prim.getAttr(LuxTokens.lightShaderId);
  }
  void VolumeLightAPI::setShaderId(const Token& value, fdk::TimeValue time) {
    createShaderIdAttr().setValue(value, time);
  }
  Token VolumeLightAPI::getShaderId(fdk::TimeValue time) const {
    Token v; _prim.getAttr(LuxTokens.lightShaderId).getValue<Token>(v, time); return v;
  }


  // --(BEGIN CUSTOM CODE)--
  // --(END CUSTOM CODE)--
}
}
